//
// File: DepotNodeClass.h
// Created by: chochmah <chochmah@localhost>
// Created on: Wed Jan 14 20:11:10 2004
//

#include "DepotNodeClass.h"
#include <FL/Fl.H>
#include <FL/Fl_Window.H>
#include <FL/Fl_Toggle_Button.H>
#include <FL/Fl_Menu_Button.H>
#include <FL/Fl_Box.H>
#include <FL/Fl_Input.H>
#include <FL/Fl_Select_Browser.H>
#include <FL/Fl_Hold_Browser.H>
#include <FL/Fl_Button.H>
#include <FL/Fl_Repeat_Button.H>
#include <FL/Fl_Group.H>
#include <FL/Fl_Window.H>
#include <FL/Fl_Scroll.H>
#include <FL/Fl_Value_Slider.H>
#include <FL/Fl_Check_Button.H>
#include <FL/Fl_Pack.H>
#include <FL/Fl_Text_Display.H>
#include <FL/Fl_GIF_Image.H>
#include <FL/Fl_Image.H>
#include "images.h"
#include "ZugClass.h"
#include "land.h"
#include "structs2.h"
#include "RailNetworkClass.h"

//-------------------externals
extern testwindow *window;
extern ZUGNODE *selectetzug;
extern int SWidth;
extern int SHeight;
extern int fieldposx;
extern int fieldposy;
extern ObjectClass *objectclasslistfirst;
extern ObjectClass *objectclasslistlast;
extern LandscapeClass *prv;
extern RailNetworkClass *RN;
extern ObjectClass *hcm[100];
extern void (createthread)(int x);

int xp,yp;

DepotNodeClass::DepotNodeClass()
{
	// TODO: put constructor code here
}


DepotNodeClass::~DepotNodeClass()
{
	// TODO: put destructor code here
}

void DepotNodeClass::select() {
	createdepotwindow();
}

static void updatespecswindow(Fl_Widget *o,int*) {
	
}


void newTrain(Fl_Widget *o,int xpos,int ypos) {
	ZugClass *zug=0;
	zug=prv->AppendZug(xp,yp,RN->RailTrackfirst[xp][yp],0);			
	for (int i=0;i<5;i++) zug->AppendWagon(hcm[21]);					
	zug->AppendWagon(hcm[18]);
	prv->Hilf(zug);	
	createthread(1);	
}




void DepotNodeClass::createdepotwindow() {
	window->begin();
  
	optionswindow = new testwindow(FL_EMBOSSED_BOX,10,40,380,240,"options^");

	{ Fl_Button* o = new Fl_Button(194, 111, 40, 20);
      o->image(image_exit2);
      o->callback((Fl_Callback*)newTrain);
//	  o->callback(newTrain,optionswindow);
		xp=xpos;yp=ypos;
		o->callback((Fl_Callback*)newTrain, (int*)(xpos));
    }
	
	{ Fl_Scroll* m = new Fl_Scroll(2, 111, 190, 105);
	  m->type(2);
      m->box(FL_FLAT_BOX);
      m->color(46);
	  int counter=0;
		ObjectClass *objcl=objectclasslistfirst;
		while(objcl) {
			if (((objcl->wagon)||objcl->engine)) {
				
      		counter++;
			{ Fl_Repeat_Button* o = new Fl_Repeat_Button(15, counter*20, 30, 25);
    		  o->box(FL_NO_BOX);
	    	  o->image(objcl->gifimage);
      		  o->align(FL_ALIGN_BOTTOM_LEFT|FL_ALIGN_INSIDE);
    		}
    		{ Fl_Button* o = new Fl_Button(50, 5+counter*20, 120, 20, objcl->objectname);
      			o->box(FL_NO_BOX);
				o->callback((Fl_Callback*)updatespecswindow, (void*)(counter));
    		}
		}
		objcl=objcl->pNext;
	}
	
	
	m->end();
	}
	
	
	{ Fl_Scroll* m = new Fl_Scroll(2, 2, 350, 105);
	  //m->type(6);
      m->box(FL_FLAT_BOX);
      m->color(46);
	  int counter=0;
		ZUGNODE *zugNode=prv->firstzug;
		
		while (zugNode!=0) {
      		counter++;
			for (int i=0;i<zugNode->zug.wagoncounter;i++) {
				{ Fl_Repeat_Button* o = new Fl_Repeat_Button(15+i*30, counter*20, 28, 12);
    			  o->box(FL_NO_BOX);
				if (((zugNode->zug.wag[i]->wagon)||zugNode->zug.wag[i]->engine)) {
	    		  o->image(zugNode->zug.wag[i]->gifimage);
				}
    			}
			}
		zugNode=zugNode->pNext;
	}
	m->position(1,1);
	m->end();
	m->position(1,1);
	}
	optionswindow->resizable(optionswindow);
  	optionswindow->resizable(optionswindow);
  	optionswindow->end();
  	optionswindow->show();
	
	window->end();
	window->show();		
}



