//
// File: ObjectClass.h
// Created by: chochmah <chochmah@localhost>
// Created on: Fri Sep 19 15:05:26 2003
//

#include "ObjectClass.h"
#include "string.h"
#include "unistd.h"
#include "triloader.h"
//#include "MilkshapeModel.h"



extern GNODE *goodlistfirst;
extern GNODE *goodlistlast;

extern CLoad3DS g_Load3ds;										// This is 3DS class.  This should go in a good model class.
extern t3DModel g_3DModel;										// This holds the 3D Model info that we load in


ObjectClass::ObjectClass()
{
	producelistfirst=0;
	requirelistfirst=0;
	wagon=0;
}


ObjectClass::~ObjectClass()
{
	// TODO: put destructor code here
}

void ObjectClass::AppendProduction(char *name, int amount) {
	PRODNODE *newNode;
	newNode = new PRODNODE;
	GNODE *gNode=goodlistfirst;
	int s=0;
	while (gNode!=0) {
		if (cmp(gNode->name,name)) {newNode->good=gNode;s=1;}
		gNode=gNode->pNext;
	}
	if (s==0) printf("FATAL ERROR 876: goodtype %s not found\n",name);
	
	//strcpy(newNode->name,name);
	newNode->amount=amount;
	if (producelistfirst == 0) {
      producelistfirst = newNode;
      producelistfirst->pPrev = 0;
   }
   else {
      producelistlast->pNext = newNode;
      newNode->pPrev = producelistlast;
   }
   producelistlast=newNode;
   producelistlast->pNext = 0;  
}

void ObjectClass::AppendRequire(char *name, int amount) {
	PRODNODE *newNode;
	newNode = new PRODNODE;
	GNODE *gNode=goodlistfirst;
	int s=0;
	while (gNode!=0) {
		if (cmp(gNode->name,name)) {newNode->good=gNode;s=1;}
		gNode=gNode->pNext;
	}
	if (s==0) printf("FATAL ERROR 876: goodtype %s not found\n",name);
	
	//strcpy(newNode->name,name);
	newNode->amount=amount;
	if (requirelistfirst == 0) {
      requirelistfirst = newNode;
      requirelistfirst->pPrev = 0;
   }
   else {
      requirelistlast->pNext = newNode;
      newNode->pPrev = requirelistlast;
   }
   requirelistlast=newNode;
   requirelistlast->pNext = 0;  
}

/* Image type - contains height, width, and data */
struct Image {
    unsigned long sizeX;
    unsigned long sizeY;
    char *data;
};
typedef struct Image Image;

int ObjectClass::ImageLoad(char *filename, Image *image) {
    FILE *file;
    unsigned long size;                 // size of the image in bytes.
    unsigned long i;                    // standard counter.
    unsigned short int planes;          // number of planes in image (must be 1) 
    unsigned short int bpp;             // number of bits per pixel (must be 24)
    char temp;                          // temporary color storage for bgr-rgb conversion.

    // make sure the file is there.
    if ((file = fopen(filename, "rb"))==NULL)
    {
	printf("File Not Found : %s\n",filename);
	return 0;
    }
    
    // seek through the bmp header, up to the width/height:
    fseek(file, 18, SEEK_CUR);

    // read the width
    if ((i = fread(&image->sizeX, 4, 1, file)) != 1) {
	printf("Error reading width from %s.\n", filename);
	return 0;
    }
    printf("Width of %s: %lu\n", filename, image->sizeX);
    
    // read the height 
    if ((i = fread(&image->sizeY, 4, 1, file)) != 1) {
	printf("Error reading height from %s.\n", filename);
	return 0;
    }
    printf("Height of %s: %lu\n", filename, image->sizeY);
    
    // calculate the size (assuming 24 bits or 3 bytes per pixel).
    size = image->sizeX * image->sizeY * 3;

    // read the planes
    if ((fread(&planes, 2, 1, file)) != 1) {
	printf("Error reading planes from %s.\n", filename);
	return 0;
    }
    if (planes != 1) {
	printf("Planes from %s is not 1: %u\n", filename, planes);
	return 0;
    }

    // read the bpp
    if ((i = fread(&bpp, 2, 1, file)) != 1) {
	printf("Error reading bpp from %s.\n", filename);
	return 0;
    }
    if (bpp != 24) {
	printf("Bpp from %s is not 24: %u\n", filename, bpp);
	return 0;
    }
	
    // seek past the rest of the bitmap header.
    fseek(file, 24, SEEK_CUR);

    // read the data. 
    image->data = (char *) malloc(size);
    if (image->data == NULL) {
	printf("Error allocating memory for color-corrected image data");
	return 0;	
    }

    if ((i = fread(image->data, size, 1, file)) != 1) {
	printf("Error reading image data from %s.\n", filename);
	return 0;
    }
	/*
	for (i=0;i<size;i++) {
		printf("[%i]",(int)image->data[i]);
	}*/
    for (i=0;i<size;i+=3) { // reverse all of the colors. (bgr -> rgb)
	temp = image->data[i];
	image->data[i] = image->data[i+2];
	image->data[i+2] = temp;
    }
    
    // we're done.
    return 1;
}


void ObjectClass::loadmodel3ds(char *filename,int m) {		
	unsigned int g_Texture[100] = {0};						// This holds the texture info, referenced by an ID

	chdir("../");chdir("models");	
	
	printf("loading-1- %s\n",filename);	
	g_Load3ds.Import3DS(&g_3DModel,filename);			// Load our .3DS file into our model structure		
	
	for(int i = 0; i < g_3DModel.numOfMaterials; i++)
	{		
		if(strlen(g_3DModel.pMaterials[i].strFile) > 0)
		{			
			
	Image *image3;
	image3 = (Image *) malloc(sizeof(Image));
    if (image3 == NULL) {
	printf("Error allocating space for image");
	exit(0);
    }
	printf("->load %s\n",g_3DModel.pMaterials[i].strFile);
    if (!ImageLoad(g_3DModel.pMaterials[i].strFile, image3)) {
	exit(1);
    }        
	// Create Texture	    
    glGenTextures(1, &g_Texture[i]);
    glBindTexture(GL_TEXTURE_2D, g_Texture[i]);   // 2d texture (x and y size)
    glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR); // scale linearly when image bigger than texture
    glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR); // scale linearly when image smalled than texture
    glTexImage2D(GL_TEXTURE_2D, 0, 3, image3->sizeX, image3->sizeY, 0, GL_RGB, GL_UNSIGNED_BYTE, image3->data);	
		// Set the texture ID for this material
		g_3DModel.pMaterials[i].texureId = i;
	}

	
	}
	
	chdir("../");chdir("objects");
	
	glNewList(currentObject,GL_COMPILE);
	ObjectList[m]=currentObject;
		
	// Since we know how many objects our model has, go through each of them.
	for(int i = 0; i < g_3DModel.numOfObjects; i++)
	{
		// Make sure we have valid objects just in case. (size() is in the vector class)
		if(g_3DModel.pObject.size() <= 0) break;

		// Get the current object that we are displaying
		t3DObject *pObject = &g_3DModel.pObject[i];
			
		// Check to see if this object has a texture map, if so bind the texture to it.
		if(pObject->bHasTexture) {

			// Turn on texture mapping and turn off color
			glEnable(GL_TEXTURE_2D);

			// Reset the color to normal again
			float pc[3];
			glColor3ub(255, 255, 255);
			pc[0]=1;
			pc[1]=1;
			pc[2]=1;			
			glMaterialfv (GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE,pc);

			// Bind the texture map to the object by it's materialID
			glBindTexture(GL_TEXTURE_2D, g_Texture[pObject->materialID]);
		} else {

			// Turn off texture mapping and turn on color
			glDisable(GL_TEXTURE_2D);

			// Reset the color to normal again
			glColor3ub(255, 255, 255);
		}

		// This determines if we are in wireframe or normal mode
		glBegin(GL_TRIANGLES);					// Begin drawing with our selected mode (triangles or lines)

			// Go through all of the faces (polygons) of the object and draw them
			for(int j = 0; j < pObject->numOfFaces; j++)
			{
				// Go through each corner of the triangle and draw it.
				for(int whichVertex = 0; whichVertex < 3; whichVertex++)
				{
					// Get the index for each point of the face
					int index = pObject->pFaces[j].vertIndex[whichVertex];
			
					// Give OpenGL the normal for this vertex.
					glNormal3f(pObject->pNormals[ index ].x, pObject->pNormals[ index ].y, pObject->pNormals[ index ].z);
				
					// If the object has a texture associated with it, give it a texture coordinate.
					if(pObject->bHasTexture) {

						// Make sure there was a UVW map applied to the object or else it won't have tex coords.
						if(pObject->pTexVerts) {
							glTexCoord2f(pObject->pTexVerts[ index ].x, pObject->pTexVerts[ index ].y);
						}
					} else {

						// Make sure there is a valid material/color assigned to this object.
						// You should always at least assign a material color to an object, 
						// but just in case we want to check the size of the material list.
						// if the size is at least one, and the material ID != -1,
						// then we have a valid material.
						if(g_3DModel.pMaterials.size() && pObject->materialID >= 0) 
						{
							// Get and set the color that the object is, since it must not have a texture
							unsigned char *pColor = g_3DModel.pMaterials[pObject->materialID].color;

							// Assign the current color to this model
							float pc[3];
							pc[0]=(float)pColor[0]/256;
							pc[1]=(float)pColor[1]/256;
							pc[2]=(float)pColor[2]/256;							
							glColor3ub(pColor[0], pColor[1], pColor[2]);
							glMaterialfv (GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE,pc);
							glColor3f(pColor[0],pColor[1],pColor[2]);
						}
					}

					// Pass in the current vertex of the object (Corner of current face)
					
					
    				//glNormal3fv (norm[i]);
					glVertex3f(pObject->pVerts[ index ].x, pObject->pVerts[ index ].y, pObject->pVerts[ index ].z);
				}
			}

		glEnd();								// End the drawing
	}
	
	glColor3ub(255, 255, 255);
	glEndList();
	currentObject++;
	
}

void ObjectClass::LoadGifImage(char *name) {
	chdir("../");chdir("models");		
	gifimage = new Fl_GIF_Image(name);
	chdir("../");chdir("objects");
}

void ObjectClass::loadmodeltri(char *filename,int m) {
	chdir("../");chdir("models");		
	loadfileobject (filename);
	int i;
	
	glNewList(currentObject,GL_COMPILE);
	ObjectList[m]=currentObject;
	//printf("object %i zugewiesen\n",currentObject);
  glDisable(GL_TEXTURE_2D);	
  for (i = 0; i < size; i++) {
    glBegin (GL_TRIANGLES);
    glMaterialfv (GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE,(color[i]));
	glColor3f(color[i][0],color[i][1],color[i][2]);
    glNormal3fv (norm[i]);
    glVertex3f (tri[0][0][i],
		tri[0][1][i],
		tri[0][2][i]);
    glVertex3f (tri[1][0][i],
		tri[1][1][i],
		tri[1][2][i]);
    glVertex3f (tri[2][0][i],
		tri[2][1][i],
		tri[2][2][i]);
    glEnd ();
  }
  
	glEndList();
	
	currentObject++;
	chdir("../");chdir("objects");
}

bool ObjectClass::cmp(char *s1,char *s2) {
int i=0;
	while ((s1[i]!='\0')||(s2[i]!='\0')) {
		//printf("[%c,%c]",s1[i],s2[i]);
		if (s1[i]!=s2[i]) return 0;
		i++;
	}
	return(1);
}


void ObjectClass::print() {
	FILE *fd;
	if (NULL == (fd = fopen ("debuglog.txt", "a")))
		{
		printf("error!\n");
		printf("can't open debugoutput file", "debuglog");
	} 
		
	fprintf(fd,"Objectname: %s\n",objectname);
	fprintf(fd,"| Modelle:: 1:%s 2:%s 3:%s\n",model1,model2,model3);
	fprintf(fd,"| type: %s\n",type);
	if (cmp(type,"industrie")) {
		fprintf(fd,"| size: %i %i\n",sizex,sizey);
		PRODNODE *PNode=producelistfirst;
		while (PNode!=0) {
			fprintf(fd,"produces: %s, amount %i\n",PNode->good->name, PNode->amount);
			PNode=PNode->pNext;
		}
		//printf("| requires: %s, produce %s, productionamount: %i\n",requires,produce,productionamount);
	}
	if (cmp(type,"engine")) {
		fprintf(fd,"| maxspeed: %i\n",maxspeed);
		fprintf(fd,"| ps: %i\n",ps);
		fprintf(fd,"| length: %i\n",length);
	}
	if (cmp(type,"wagon")) {		
		fprintf(fd,"| length: %i\n",length);
	}
	fclose(fd);
}

GNODE *ObjectClass::getgood(char *name) {
	GNODE *gNode=goodlistfirst;
	while (gNode!=0) {
		if (cmp(name,gNode->name)) return(gNode);
		gNode=gNode->pNext;
	}
	return(0);	
}


void ObjectClass::load(char *fn) {	
	char b[200];
	getcwd(b,200);
	if (chdir("objects")) printf("error cant chdir to objects\n");
	getcwd(b,200);
	//printf("dir: %s\n",b);
	//printf("loading object %s\n",fn);
	FILE *fd;
	if (NULL == (fd = fopen (fn, "r")))
		{
		printf("error!\n");
		printf("LoadObjectClass: Can't open this '%s', ejecting!\n", fn);
		} //else printf("file %s loadet\n",fn);	
	char name[100];
	for (int i=0;i<100;i++) {	
		char s1[100];
		char s2[100];
		fscanf (fd, "%s\n%s\n",&s1,&s2);
		//printf("[%s][%s]\n",s1,s2);
		if (cmp(s1,"objectname")) strcpy(objectname,s2);
		if (cmp(s1,"model1")) {strcpy(model1,s2);loadmodeltri(model1,0);}		
		if (cmp(s1,"model2")) {strcpy(model2,s2);loadmodeltri(model2,1);}		
		if (cmp(s1,"model3")) {strcpy(model3,s2);loadmodeltri(model3,2);}		
		if (cmp(s1,"model1full")) {strcpy(model1full,s2);loadmodeltri(model1full,3);}		
		if (cmp(s1,"model2full")) {strcpy(model2full,s2);loadmodeltri(model2full,4);}		
		if (cmp(s1,"model3full")) {strcpy(model3full,s2);loadmodeltri(model3full,5);}		
		if (cmp(s1,"model13ds")) {strcpy(model1,s2);loadmodel3ds(model1,0);}		
		if (cmp(s1,"model23ds")) {strcpy(model2,s2);loadmodel3ds(model2,1);}		
		if (cmp(s1,"model33ds")) {strcpy(model3,s2);loadmodel3ds(model3,2);}		
		if (cmp(s1,"model1full3ds")) {strcpy(model1full,s2);loadmodel3ds(model1full,3);}		
		if (cmp(s1,"model2full3ds")) {strcpy(model2full,s2);loadmodel3ds(model2full,4);}		
		if (cmp(s1,"model3full3ds")) {strcpy(model3full,s2);loadmodel3ds(model3full,5);}
		if (cmp(s1,"gifimage")) {LoadGifImage(s2);}
		if (cmp(s1,"loads")) loads=getgood(s2);
		if (cmp(s1,"type")) strcpy(type,s2);
		if (cmp(s1,"sizex")) sizex=atoi(s2);
		if (cmp(s1,"sizey")) sizey=atoi(s2);
		if (cmp(s1,"capacity")) capacity=atoi(s2);
		if (cmp(s1,"maxspeed")) maxspeed=atoi(s2);
		if (cmp(s1,"ps")) ps=atoi(s2);
		if (cmp(s1,"length")) length=atoi(s2);
		if (cmp(s1,"axevorn")) axevorn=atoi(s2);
		if (cmp(s1,"axehinten")) axehinten=atoi(s2);
		if (cmp(s1,"produce")) strcpy(name,s2);
		if (cmp(s1,"requires")) strcpy(name,s2);
		if (cmp(s1,"productionamount")) AppendProduction(name,atoi(s2));
		if (cmp(s1,"requiresamount")) AppendRequire(name,atoi(s2));
		if (cmp(s1,"endef")) goto fertig;
	}	
	fertig:
	if (chdir("../")) printf("error\n");
	getcwd(b,200);
	//printf("dir: %s\n",b);
	if (cmp(type,"wagon")) wagon=1;
	if (cmp(type,"engine")) engine=1;
	print();
	
}
