//
// File: ObjectClass.h
// Created by: chochmah <chochmah@localhost>
// Created on: Fri Sep 19 15:05:26 2003
//

#ifndef _OBJECTCLASS_H_
#define _OBJECTCLASS_H_

#include <stdio.h>
#include <stdlib.h>
#include "main.h"
#include "3ds.h"
#include "GNODE.h"
#include <GL/gl.h>	// Header File For The OpenGL32 Library
#include <GL/glu.h>	// Header File For The GLu32 Library

#include <FL/Fl.H>
#include <FL/Fl_GIF_Image.H>
#include <FL/Fl_Image.H>

extern int currentObject;
extern GNODE *goodlistfirst;
extern GNODE *goodlistlast;

struct PRODNODE {
	PRODNODE *pNext;
	PRODNODE *pPrev;
	GNODE *good;
	int amount;
};

class ObjectClass
{
	struct Image {
    unsigned long sizeX;
    unsigned long sizeY;
    char *data;
	};
	typedef struct Image Image;

	public:	
		Fl_GIF_Image *gifimage;
		PRODNODE *producelistfirst;		
		PRODNODE *producelistlast;		
		PRODNODE *requirelistfirst;
		PRODNODE *requirelistlast;
		int ObjectList[6];				
		char objectname[100];
		char model1[100];
		char model2[100];
		char model3[100];
		char model1full[100];
		char model2full[100];
		char model3full[100];
		char type[100];	
	    int capacity;
		GNODE *loads;
		bool wagon;
		bool engine;
		unsigned char length;
		unsigned char axevorn, axehinten;		
		int sizex,sizey,maxspeed,ps;
		ObjectClass *pPrev;
		ObjectClass *pNext;
		ObjectClass();
		 ~ObjectClass();
		void load(char *fn);		
		void print();
		int ImageLoad(char *filename, Image *image);
		void loadmodeltri(char *filename,int m);
		void loadmodel3ds(char *filename,int m);
		void AppendProduction(char *name, int amount);
		bool cmp(char *s1,char *s2);
		GNODE *getgood(char *name);
		void AppendRequire(char *name, int amount);
		void LoadGifImage(char *name);
	protected:
};


#endif	//_OBJECTCLASS_H_

