#include <GL/gl.h>	// Header File For The OpenGL32 Library
#include <GL/glu.h>	// Header File For The GLu32 Library
#include "GL/glut.h"
#include <sys/time.h>
#include <stdio.h>

struct timeval frameStartTime, frameEndTime;

float fbuffer[30];
int fbufferpointer=0;

void frameStart(void) {
  gettimeofday(&frameStartTime, NULL);
}

void frameEnd(void *font, GLclampf r, GLclampf g, GLclampf b, 
              GLfloat x, GLfloat y) {
  /* font: font to use, e.g., GLUT_BITMAP_HELVETICA_10
     r, g, b: text colour
     x, y: text position in window: range [0,0] (bottom left of window)
           to [1,1] (top right of window). */

  float elapsedTime; 
  char str[30]; 
  char *ch; 
  GLint matrixMode;
  GLboolean lightingOn;

  gettimeofday(&frameEndTime, NULL);

  elapsedTime= frameEndTime.tv_sec - frameStartTime.tv_sec +
             ((frameEndTime.tv_usec - frameStartTime.tv_usec)/1.0E6);
  fbuffer[fbufferpointer]=elapsedTime;
  fbufferpointer++;
  if (fbufferpointer>30) fbufferpointer=0;
  float mittel=0;
  for (int i=0;i<30;i++) mittel+=fbuffer[i];
  sprintf(str, "Fps: %2.0f MFps: %2.2f", 1.0/elapsedTime,30.0/mittel);

 lightingOn= glIsEnabled(GL_LIGHTING);        /* lighting on? */
 if (lightingOn) glDisable(GL_LIGHTING);

 glGetIntegerv(GL_MATRIX_MODE, &matrixMode);  /* matrix mode? */

 glMatrixMode(GL_PROJECTION);
 glPushMatrix();
   glLoadIdentity();
   gluOrtho2D(0.0, 1.0, 0.0, 1.0);
   glMatrixMode(GL_MODELVIEW);
   glPushMatrix();
     glLoadIdentity();
     glPushAttrib(GL_COLOR_BUFFER_BIT);       /* save current colour */
       glColor3f(r, g, b);
 	   glRasterPos3f(x, y, 1.0);
       for(ch= str; *ch; ch++) {
          glutBitmapCharacter(font, (int)*ch);
       }
     glPopAttrib();
   glPopMatrix();
   glMatrixMode(GL_PROJECTION);
 glPopMatrix();
 glMatrixMode(matrixMode);
 if (lightingOn) glEnable(GL_LIGHTING);
}

/* end of frames.h */
