#include <FL/Fl.H>
#include <FL/Fl_Window.H>
#include <FL/Fl_Toggle_Button.H>
#include <FL/Fl_Menu_Button.H>
#include <FL/Fl_Box.H>
#include <FL/Fl_Input.H>
#include <FL/Fl_Select_Browser.H>
#include <FL/Fl_Hold_Browser.H>
#include <FL/Fl_Button.H>
#include <FL/Fl_Repeat_Button.H>
#include <FL/Fl_Group.H>
#include <FL/Fl_Window.H>
#include <FL/Fl_Scroll.H>
#include <FL/Fl_Value_Slider.H>
#include <FL/Fl_Check_Button.H>
#include <FL/Fl_Pack.H>
#include <FL/Fl_Text_Display.H>
//#include <FL/Fl_GIF_Image.H>
#include <FL/Fl_Image.H>
#include "images.h"


//-------------------externals
extern ZUGNODE *selectetzug;
extern int SWidth;
extern int SHeight;
extern int fieldposx;
extern int fieldposy;
extern ObjectClass *objectclasslistfirst;
extern ObjectClass *objectclasslistlast;
extern LandscapeClass *prv;


//-------------------SchalterVariabeln
bool Grid=0;
bool Polys=1;
bool editterrain=0;
bool laytrack=0;
bool bahnsteigbuild=0; // schalter frs bauen von Bahnsteigen in Bahnhfen
bool pillarbuild=0; //schalter fr bauen von Brckenpfeilern
bool buildtrainstation=0; //schalter fr das Bauen von Bahnhfen
bool spawnbuild=0; //schalter fr das spannen von Brcken
bool signalbuild=0; //setzen von signalen
bool depotbuild=0; // vorlufig!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
bool zugselect=0; // auswhlen von Zgen
bool fahrplan=0; // schalter fr das auswhlen von FahrplanSuperNodes
bool showsupernodenetwork; //schalter frs ein und ausschlaten der supernodenetzdarstellung
bool deletetrack; //schalter frs demolieren von tracks;
bool showfahrplaene=0;
bool showsignalnetwork=0;
bool evaderedsignals=1;
bool selectdepot=0;

//--------------
bool zugwindowactiv=0;


Fl_Menu_Button* popup;

#include <testwindow.h>

testwindow *buttonbar;
testwindow *optionswindow;
testwindow *subwindow3;
Fl_Hold_Browser* fahrplanbrowser;
extern testwindow *window;

void disableswitches() {
	editterrain=0;
	laytrack=0;
	pillarbuild=0;
	spawnbuild=0;
	signalbuild=0;
	depotbuild=0;
	zugselect=0;
	fahrplan=0;
	deletetrack=0;
}


void update_fahrplan_window() {
	int fppointer=fahrplanbrowser->value();
	fahrplanbrowser->clear();
	FAHRPLANNODE *fNode=selectetzug->zug.fahrplannodefirst;
	while (fNode!=0) {
		char text[50];
		char t2[3];
		if (fNode==selectetzug->zug.fahrplanpointer) sprintf(t2,"->"); else sprintf(t2,"<-");
		if (fNode->target==1) sprintf(text,"%sBahnhof (%i,%i)",t2,fNode->tsNode->x,fNode->tsNode->y);		
		if (fNode->target==0) sprintf(text,"%sWaypoint (%i,%i)",t2,fNode->SuperNode->x,fNode->SuperNode->y);		
		fahrplanbrowser->add(text);
		fNode=fNode->pNext;
	}
	fahrplanbrowser->value(fppointer);
}

void new_waypoint(Fl_Widget *o, void *p) {
	disableswitches();
	fahrplan=1;
}

void centerview(Fl_Widget *o,void *p) {
	fieldposx=selectetzug->zug.x;
	fieldposy=selectetzug->zug.y;
}

void skipwaypoint(Fl_Widget *o,void *p) {
	if (selectetzug->zug.fahrplanpointer->pNext==NULL) selectetzug->zug.fahrplanpointer=selectetzug->zug.fahrplannodefirst;
		else selectetzug->zug.fahrplanpointer=selectetzug->zug.fahrplanpointer->pNext;
	selectetzug->zug.aktion=1;
	update_fahrplan_window();
}

void killwindow(Fl_Widget *o,void *p) {
	zugwindowactiv=0;
	subwindow3->~testwindow();
}

void removewaypoint(Fl_Widget *o,void *p) {
	selectetzug->zug.removewaypoint(fahrplanbrowser->value());
	update_fahrplan_window();
}


static void cb_grid(Fl_Check_Button*, void*) {
  Grid=!Grid;
}

static void cb_terraintextures(Fl_Check_Button*, void*) {
  int i=1;
	i=2;
}

static void cb_reroute(Fl_Check_Button*, void*) {
  evaderedsignals=!evaderedsignals;
}

static void cb_supernodes(Fl_Check_Button*, void*) {
  showsupernodenetwork=!showsupernodenetwork;
}

static void cb_signalconnections(Fl_Check_Button*, void*) {
  showsignalnetwork=!showsignalnetwork;
}

static void cb_trainroutes(Fl_Check_Button*, void*) {
  showfahrplaene=!showfahrplaene;
}




void createoptionswindow() {
	window->begin();
  
	optionswindow = new testwindow(FL_EMBOSSED_BOX,10,40,380,370,"options^");

    { Fl_Check_Button* o = new Fl_Check_Button(5, 0, 25, 25, "grid");
      o->down_box(FL_DOWN_BOX);
      o->callback((Fl_Callback*)cb_grid);
    }
    { Fl_Check_Button* o = new Fl_Check_Button(5, 20, 25, 25, "terraintextures");
      o->down_box(FL_DOWN_BOX);
      o->callback((Fl_Callback*)cb_terraintextures);
    }
    { Fl_Check_Button* o = new Fl_Check_Button(5, 40, 25, 25, "dont reroute at red");
      o->down_box(FL_DOWN_BOX);
      o->callback((Fl_Callback*)cb_reroute);
    }
    { Fl_Check_Button* o = new Fl_Check_Button(5, 70, 25, 25, "supernodes");
      o->down_box(FL_DOWN_BOX);
      o->callback((Fl_Callback*)cb_supernodes);
    }
    { Fl_Check_Button* o = new Fl_Check_Button(5, 90, 25, 25, "signalconnections");
      o->down_box(FL_DOWN_BOX);
      o->callback((Fl_Callback*)cb_signalconnections);
    }
    { Fl_Check_Button* o = new Fl_Check_Button(5, 110, 25, 25, "trainroutes");
      o->down_box(FL_DOWN_BOX);
      o->callback((Fl_Callback*)cb_trainroutes);
    }

	optionswindow->resizable(optionswindow);
  	optionswindow->resizable(optionswindow);
  	optionswindow->end();
  	optionswindow->show();
	window->end();
	window->show();		
}




void createzugwindow() {
	//neues Fenster mit Zugeigenschaften::---------------------
	
	if (zugwindowactiv) {
		zugwindowactiv=0;
		subwindow3->~testwindow();	
	}
	zugwindowactiv=1;
	window->begin();
  
	subwindow3 = new testwindow(FL_EMBOSSED_BOX,10,SHeight-160,331,150,"ZugX");

	{ Fl_Button* o = new Fl_Button(2, 136, 53, 12);
      o->image(image_skip);
	  o->callback(skipwaypoint,subwindow3);
    }
	{ Fl_Button* o = new Fl_Button(55, 136, 53, 12);
      o->image(image_reset);
	  o->callback(removewaypoint,subwindow3);
    }
    { Fl_Button* o = new Fl_Button(108, 136, 53, 12);
      o->image(image_goto);
	  o->callback(new_waypoint,subwindow3);
    }
    { Fl_Button* o = new Fl_Button(161, 136, 53, 12);
      o->image(image_fullload);
    }
    { Fl_Button* o = new Fl_Button(214, 136, 53, 12);
      o->image(image_unload);
    }
    { Fl_Button* o = new Fl_Button(257, 136, 53, 12);
      o->image(image_nonstop);
    }
	
	{ Fl_Button* o = new Fl_Button(312, 2, 17, 17);
      o->image(image_ignoresignal);
    }
    { Fl_Button* o = new Fl_Button(312, 19, 17, 17);
      o->image(image_depot);
    }
    { Fl_Button* o = new Fl_Button(312, 36, 17, 17);
      o->image(image_reversetrain);
	}
    { Fl_Button* o = new Fl_Button(312, 53, 17, 17);
      o->image(image_lockview);
	  o->callback(centerview,subwindow3);
    }
	{ Fl_Button* o = new Fl_Button(315, 90, 13, 13);
      o->image(image_exit2);
      o->callback((Fl_Callback*)killwindow);
    }
	
	{ fahrplanbrowser = new Fl_Hold_Browser(2, 2, 310, 134);
	  	
	update_fahrplan_window();	
    fahrplanbrowser->color(68);	  
	fahrplanbrowser->textcolor(95);	
    }
	
  subwindow3->resizable(subwindow3);
  window->resizable(subwindow3);
  subwindow3->end();
  subwindow3->show();
		window->end();
window->show();		
		//--------------------------------------------------------
}
