#include <FL/glut.H>    // Header File For The GLUT Library 

#include <GL/gl.h>	// Header File For The OpenGL32 Library
#include <GL/glu.h>	// Header File For The GLu32 Library
#include <GL/glut.h>
#include <unistd.h>     // needed to sleep

#include "frames.h"
#include "main.h"
#include "3ds.h"
#include "math.h"
#include "land.h"
#include <pthread.h>
#include "Cam.h"
#include "LandClass.h"
#include <dirent.h>

#include "string.h"
#include "unistd.h"
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <limits.h>           /* ULONG_MAX is defined here */
#include <float.h>            /* FLT_MAX is atleast defined here */
#include "config.h"
#include "TextBubbelClass.h"
#include "gui.h"
#include "options.h"

#define ESCAPE 27



int glutwindow; 
float rtri = 0.0f;
float rquad = 0.0f;

//tempna
GLuint tpo;
void (createthread)(int x);



//------------------- Landscape
float Highscale=0.08;
float AspectRatio; // Verhltnis von ViewportWeite zu Viewporthhe
int VSize=10; // Sichtbarer auschnitt in Spielwelt
LandClass *Landscape;
LandscapeClass *prv;
int fieldposx=138;
int fieldposy=48;
int cfx,cfy; // Position des Cursors in der Landschaft auf Hoehenpunkt
int ckx, cky; //Position des Cursors in der Landschaft auf Kachel


//------------------- Tracknetwork
RailNetworkClass *RN;
unsigned char tracktype=1; //Art der Schiene die im Moment zum Bau ausgewhlt ist
RNODE *rnode; //momentan aktiver track beim signalsetzen;
int sigx;
int sigy; // momentanes signal x und y

//---------------------Bahnhoefe

bool drawbahnsteig=0; //zeichnen von bahnsteiggrid
int bsteigxstart,bsteigystart,bsteigxend,bsteigyend;
TSNODE *activeTS;

//------------------- Bruecken
int oldmousex,oldmousey;
int pillarx,pillary,pillarhight;
bool pillargrid=0;
int spawnxstart,spawnystart,spawnxend,spawnyend;
bool drawspawn=0;

//------------------- 3DS FileLoader & ObjectList
CLoad3DS g_Load3ds;										// This is 3DS class.  This should go in a good model class.
t3DModel g_3DModel;										// This holds the 3D Model info that we load in
int currentObject=0;
ObjectClass *hcm[100];
#include "main.h"										// This includes our header file

unsigned int g_Texture[100] = {0};						// This holds the texture info, referenced by an ID



//-------------------- Bildschirm
bool scrolldown=0;
bool scrollup=0;
bool scrollright=0;
bool scrollleft=0;

bool isappending;
bool isdrawing;
float xS=1.4;
float yS;
int rotateview=0;
int SWidth, SHeight;
bool zugsicht=0;
Camera cam;
float campos[3];
float camlookdir[3];
unsigned char zoom=0;

//-------------------- Zge
bool stopgame=1;
bool AmSpeichern=0;
ZUGNODE *selectetzug=0;
bool workingonmarschtabelle=0; //schaltet sich ein wenn die marschtabelle erneuert wird damit es keine fehler beim zeichnen gibt

//textbubbels
TextBubbelClass *TB;

//--------------------Threads
pthread_t TBthread;
int tbthreadid;
pthread_t MTthread;
int mtthreadid;

pthread_t threads[100];		/* holds thread info */
int ids[100];			/*  holds thread args */
int errcode;			/* holds pthread error code */
//--------------------Objecte
ObjectClass *objectclasslistfirst;
ObjectClass *objectclasslistlast;

//--------------------Goods
GNODE *goodlistfirst;
GNODE *goodlistlast;

//GUI
testwindow *window;

GLuint texture[2];

/* Image type - contains height, width, and data */
struct Image {
    unsigned long sizeX;
    unsigned long sizeY;
    char *data;
};
typedef struct Image Image;

// quick and dirty bitmap loader...for 24 bit bitmaps with 1 plane only.  
// See http://www.dcs.ed.ac.uk/~mxr/gfx/2d/BMP.txt for more info.



int ImageLoad(char *filename, Image *image) {
    FILE *file;
    unsigned long size;                 // size of the image in bytes.
    unsigned long i;                    // standard counter.
    unsigned short int planes;          // number of planes in image (must be 1) 
    unsigned short int bpp;             // number of bits per pixel (must be 24)
    char temp;                          // temporary color storage for bgr-rgb conversion.

    // make sure the file is there.
    if ((file = fopen(filename, "rb"))==NULL)
    {
	printf("File Not Found : %s\n",filename);
	return 0;
    }
    
    // seek through the bmp header, up to the width/height:
    fseek(file, 18, SEEK_CUR);

    // read the width
    if ((i = fread(&image->sizeX, 4, 1, file)) != 1) {
	printf("Error reading width from %s.\n", filename);
	return 0;
    }
    printf("Width of %s: %lu\n", filename, image->sizeX);
    
    // read the height 
    if ((i = fread(&image->sizeY, 4, 1, file)) != 1) {
	printf("Error reading height from %s.\n", filename);
	return 0;
    }
    printf("Height of %s: %lu\n", filename, image->sizeY);
    
    // calculate the size (assuming 24 bits or 3 bytes per pixel).
    size = image->sizeX * image->sizeY * 3;

    // read the planes
    if ((fread(&planes, 2, 1, file)) != 1) {
	printf("Error reading planes from %s.\n", filename);
	return 0;
    }
    if (planes != 1) {
	printf("Planes from %s is not 1: %u\n", filename, planes);
	return 0;
    }

    // read the bpp
    if ((i = fread(&bpp, 2, 1, file)) != 1) {
	printf("Error reading bpp from %s.\n", filename);
	return 0;
    }
    if (bpp != 24) {
	printf("Bpp from %s is not 24: %u\n", filename, bpp);
	return 0;
    }
	
    // seek past the rest of the bitmap header.
    fseek(file, 24, SEEK_CUR);

    // read the data. 
    image->data = (char *) malloc(size);
    if (image->data == NULL) {
	printf("Error allocating memory for color-corrected image data");
	return 0;	
    }

    if ((i = fread(image->data, size, 1, file)) != 1) {
	printf("Error reading image data from %s.\n", filename);
	return 0;
    }
	/*
	for (i=0;i<size;i++) {
		printf("[%i]",(int)image->data[i]);
	}*/
    for (i=0;i<size;i+=3) { // reverse all of the colors. (bgr -> rgb)
	temp = image->data[i];
	image->data[i] = image->data[i+2];
	image->data[i+2] = temp;
    }
    
    // we're done.
    return 1;
}
    
// Load Bitmaps And Convert To Textures
void LoadGLTextures() {	
    // Load Texture
    Image *image1;
    Image *image2;
	
    // allocate space for texture
    image1 = (Image *) malloc(sizeof(Image));
    if (image1 == NULL) {
	printf("Error allocating space for image");
	exit(0);
    }

    if (!ImageLoad("textures/land.bmp", image1)) {
	exit(1);
    }        

	image2 = (Image *) malloc(sizeof(Image));
    if (image2 == NULL) {
	printf("Error allocating space for image");
	exit(0);
    }

    if (!ImageLoad("textures/wasser.bmp", image2)) {
	exit(1);
    }        
    // Create Texture	
    glGenTextures(1, &texture[0]);
    glBindTexture(GL_TEXTURE_2D, texture[0]);   // 2d texture (x and y size)

    glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR); // scale linearly when image bigger than texture
    glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR); // scale linearly when image smalled than texture

    // 2d texture, level of detail 0 (normal), 3 components (red, green, blue), x size from image, y size from image, 
    // border 0 (normal), rgb color data, unsigned byte data, and finally the data itself.
    glTexImage2D(GL_TEXTURE_2D, 0, 3, image1->sizeX, image1->sizeY, 0, GL_RGB, GL_UNSIGNED_BYTE, image1->data);
	
	glGenTextures(1, &texture[1]);
    glBindTexture(GL_TEXTURE_2D, texture[1]);   // 2d texture (x and y size)

    glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR); // scale linearly when image bigger than texture
    glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR); // scale linearly when image smalled than texture

    // 2d texture, level of detail 0 (normal), 3 components (red, green, blue), x size from image, y size from image, 
    // border 0 (normal), rgb color data, unsigned byte data, and finally the data itself.
    glTexImage2D(GL_TEXTURE_2D, 0, 3, image2->sizeX, image2->sizeY, 0, GL_RGB, GL_UNSIGNED_BYTE, image2->data);
};


void AppendGoodTypeClass(GNODE *newNode) {
	if (goodlistfirst == 0) {
      goodlistfirst = newNode;
      goodlistfirst->pPrev = 0;
   }
   else {
      goodlistlast->pNext = newNode;
      newNode->pPrev = goodlistlast;
   }
   goodlistlast=newNode;
   goodlistlast->pNext = 0;
   printf("good appendet\n");
}

void AppendObjectClass(ObjectClass *newNode) {
	if (objectclasslistfirst == 0) {
      objectclasslistfirst = newNode;
      objectclasslistfirst->pPrev = 0;
   }
   else {
      objectclasslistlast->pNext = newNode;
      newNode->pPrev = objectclasslistlast;
   }
   objectclasslistlast=newNode;
   objectclasslistlast->pNext = 0;
   //printf("objectclass appendet\n");
}



bool cmp(char *s1,char *s2) {
int i=0;
	while ((s1[i]!='\0')||(s2[i]!='\0')) {
		//printf("[%c,%c]",s1[i],s2[i]);
		if (s1[i]!=s2[i]) return 0;
		i++;
	}
	return(1);
}




void InitGL(int Width, int Height) {
	LoadGLTextures();				// Load The Texture(s) 
    glEnable(GL_TEXTURE_2D);			// Enable Texture Mapping
  glClearColor(0.0f, 0.0f, 0.0f, 0.0f);		// This Will Clear The Background Color To Black
  glClearDepth(1.0);				// Enables Clearing Of The Depth Buffer
  glDepthFunc(GL_LESS);			        // The Type Of Depth Test To Do
  glEnable(GL_DEPTH_TEST);		        // Enables Depth Testing
  //glShadeModel(GL_DIFFUSE);			// Enables Smooth Color Shading

  glShadeModel(GL_SMOOTH);			// Enables Smooth Color Shading 
  glEnable(GL_LIGHTING);
  glEnable(GL_LIGHT0);
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();				// Reset The Projection Matrix
  //gluPerspective(45.0f,(GLfloat)Width/(GLfloat)Height,0.1f,100.0f);	// Calculate The Aspect Ratio Of The Window
  glOrtho(0,1,0,1,0,30);
  glMatrixMode(GL_MODELVIEW);
}

void ReSizeGLScene(int Width, int Height) {
  
if (Height==0)				// Prevent A Divide By Zero If The Window Is Too Small
    Height=1;
  glViewport(0, 0, Width, Height);		// Reset The Current Viewport And Perspective Transformation
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  if (zugsicht) {
    gluPerspective(45.0f,(GLfloat)Width/(GLfloat)Height,0.1f,100.0f);
	  
	  gluLookAt (
	  
	  selectetzug->zug.kx[selectetzug->zug.punktpointer]-fieldposx,
								   (selectetzug->zug.kh[selectetzug->zug.punktpointer])*Highscale+2.5, 
								   selectetzug->zug.ky[selectetzug->zug.punktpointer]-fieldposy,
	  selectetzug->zug.rx-fieldposx, 
	  			  selectetzug->zug.rh*Highscale+0.5,
	              selectetzug->zug.ry-fieldposy+1,	       		  
	       0.0, 1.0, 0.0);	
	  
    
  } else {
  	AspectRatio=(float)((float)Width/(float)Height);
  	yS=3.6/AspectRatio;
  	printf("Viewport Resize called, width = %i, hight = %i, aspect = %f\n",Width,Height,AspectRatio); 
  	SWidth=Width;
  	SHeight=Height;
  	glOrtho(-VSize,VSize,-VSize/AspectRatio,VSize/AspectRatio,-40,60);
  }
  glMatrixMode(GL_MODELVIEW);  
}

void ReSizeViewPort() {
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
	if (zugsicht) {
		gluPerspective(45.0f,800/(GLfloat)600,0.1f,100.0f);
	} else {
  		glOrtho(-VSize,VSize,-VSize/AspectRatio,VSize/AspectRatio,-40,60);
	}
  glMatrixMode(GL_MODELVIEW);  
}


int fitTrack(int x,int y,int ttype) {			
			if (ttype==5) if ((Landscape->gethigh (x,y)>Landscape->gethigh (x+1,y))&&
							  (Landscape->gethigh (x,y+1)>Landscape->gethigh (x+1,y+1))) return(7);
			if (ttype==5) if ((Landscape->gethigh (x,y)<Landscape->gethigh (x+1,y))&&
							  (Landscape->gethigh (x,y+1)<Landscape->gethigh (x+1,y+1))) return(8);			
			if (ttype==6) if ((Landscape->gethigh (x,y)>Landscape->gethigh (x,y+1))&&
							  (Landscape->gethigh (x+1,y)>Landscape->gethigh (x+1,y+1))) return(10);
			if (ttype==6) if ((Landscape->gethigh (x,y)<Landscape->gethigh (x,y+1))&&
							  (Landscape->gethigh (x+1,y)<Landscape->gethigh (x+1,y+1))) return(9);
			if (ttype==1) if ((Landscape->gethigh (x,y)==Landscape->gethigh (x,y+1))&&
						  	  (Landscape->gethigh (x,y)==Landscape->gethigh (x+1,y))&&
						  	  (Landscape->gethigh (x,y)==Landscape->getmphigh (x,y))) return(1);
			if (ttype==2) if ((Landscape->gethigh (x,y)==Landscape->gethigh (x+1,y))&&
						  	  (Landscape->gethigh (x,y)==Landscape->gethigh (x+1,y+1))&&
						  	  (Landscape->gethigh (x,y)==Landscape->getmphigh (x,y))) return(2);
			if (ttype==3) if ((Landscape->gethigh (x+1,y)==Landscape->gethigh (x,y+1))&&
						  	  (Landscape->gethigh (x+1,y)==Landscape->gethigh (x+1,y+1))&&
						  	  (Landscape->gethigh (x+1,y)==Landscape->getmphigh (x,y))) return(3);
			if (ttype==4) if ((Landscape->gethigh (x,y)==Landscape->gethigh (x,y+1))&&
						  	  (Landscape->gethigh (x,y)==Landscape->gethigh (x+1,y+1))&&
						  	  (Landscape->gethigh (x,y)==Landscape->getmphigh (x,y))) return(4);
			
			if ((Landscape->gethigh (x,y)==Landscape->gethigh (x+1,y))&&
				(Landscape->gethigh (x,y)==Landscape->gethigh (x+1,y+1))&&
				(Landscape->gethigh (x,y)==Landscape->gethigh (x,y+1))) return(ttype);	
			
	return(0);
}

void DrawmapRectangle(int x, int y,float offset) {	
	glBegin(GL_LINE_STRIP);		
			glVertex3f(x, offset+(Landscape->gethigh(x + fieldposx, y + fieldposy)) * Highscale, y);
			glVertex3f(x+1,offset+(Landscape->gethigh(x+1 + fieldposx, y + fieldposy)) * Highscale, y);
			glVertex3f(x+1,offset+(Landscape->gethigh(x+1 + fieldposx, y+1 + fieldposy)) * Highscale, y+1);
			glVertex3f(x,offset+(Landscape->gethigh(x + fieldposx, y +1+ fieldposy)) * Highscale, y+1);
			glVertex3f(x,offset+(Landscape->gethigh(x + fieldposx, y + fieldposy)) * Highscale, y);
	glEnd();	
}
void DrawRectangle(int x, int y,int h,float offset) {
	float Highscale=0.08;
	glBegin(GL_LINE_STRIP);		
			glVertex3f(x, offset+h * Highscale, y);
			glVertex3f(x+1,offset+h * Highscale, y);
			glVertex3f(x+1,offset+h * Highscale, y+1);
			glVertex3f(x,offset+h * Highscale, y+1);
			glVertex3f(x,offset+h * Highscale, y);
	glEnd();	
}


bool inview(int x,int y) {	
	if ((y+fieldposy>=0)
	  &&(y+fieldposy<Landscape->SizeY)
	  &&(x+fieldposx>=0)
	  &&(x+fieldposx<Landscape->SizeX)
	  &&(x+y>-(VSize+2)*xS)
	  &&(x+y<(VSize+1)*xS)
	  &&(x-y>-(VSize+2)*yS)
	  &&(x-y<VSize*yS)
	  &&(x+fieldposx<Landscape->SizeX-2)
	  &&(y+fieldposy<Landscape->SizeY-2)
	  ) return(1);
	return(0);
}


void DrawText(void *font, char *text, GLclampf r, GLclampf g, GLclampf b, GLfloat x, GLfloat y) {
  
  char str[30]; 
  char *ch; 
  GLint matrixMode;
  GLboolean lightingOn;
 //printf("----------->%f %f\n",(float)x,(float)y);  
 sprintf(str, text);

 lightingOn= glIsEnabled(GL_LIGHTING);       
 if (lightingOn) glDisable(GL_LIGHTING);

 glGetIntegerv(GL_MATRIX_MODE, &matrixMode); 

 glMatrixMode(GL_PROJECTION);
 glPushMatrix();
   glLoadIdentity();
   gluOrtho2D(0.0, 1.0, 0.0, 1.0);
   glMatrixMode(GL_MODELVIEW);
   glPushMatrix();
     glLoadIdentity();
     glPushAttrib(GL_COLOR_BUFFER_BIT);      
       glColor3f(r, g, b);
 	   glRasterPos3f(x, y, 1.0);
       for(ch= str; *ch; ch++) {
          glutBitmapCharacter(font, (int)*ch);
       }
     glPopAttrib();
   glPopMatrix();
   glMatrixMode(GL_PROJECTION);
 glPopMatrix();
 glMatrixMode(matrixMode);
 if (lightingOn) glEnable(GL_LIGHTING);
 
}


void DrawGLScene() {	
	
	if (scrolldown) {
		fieldposx--;
		fieldposy++;
	}
	if (scrollup) {
		fieldposx++;
		fieldposy--;
	}
	if (scrollleft) {
		fieldposx--;
		fieldposy--;
	}
	if (scrollright) {
		fieldposx++;
		fieldposy++;
	}

	glClear(GL_DEPTH_BUFFER_BIT | GL_COLOR_BUFFER_BIT);	// Clear The Screen And The Depth Buffer
  	frameStart();
	
	
  	glLoadIdentity();				// Reset The View
  	
	if (zugsicht) {		
		fieldposx=selectetzug->zug.x;
		fieldposy=selectetzug->zug.y;
		ReSizeGLScene(1024,768);
	} else {	
	glTranslatef(0.0f,-0.5f,-10.0f);		// Move Left 1.5 Units And Into The Screen 6.0
  	glRotatef(30,1.0f,0.0f,0.0f);	
  	glRotatef(rotateview+45,0.0f,1.0f,0.0f);	 
 	//glRotatef(rtri,0.0f,1.0f,0.0f);		// Rotate Landscape
	}
	
	if (selectetzug) {
		glBegin(GL_LINES);	
						glColor3f(1.0f,0.5f,1.0f);
						glVertex3f(selectetzug->zug.rx-fieldposx+0.5, (selectetzug->zug.rh+1)*Highscale, selectetzug->zug.y-fieldposy+0.5);
						glVertex3f(selectetzug->zug.kx[selectetzug->zug.punktpointer]-fieldposx,
								   (selectetzug->zug.kh[selectetzug->zug.punktpointer]+1)*Highscale, 
								   selectetzug->zug.ky[selectetzug->zug.punktpointer]-fieldposy);
		glEnd();
	}
	
	
 	int Kybegin= -45;
	int Kyend= 45;
	int Kxbegin = -45;
	int Kxend = 45;	  
  	float Highscale=0.08;
  	GLfloat lg1[4],lg2[4],lg3[4],lg4[4];
	glEnable(GL_LIGHTING);
	
	//texte
	while (isappending) {usleep(100);}
	isdrawing=1;
	
	TNODE *tnode=TB->textnodefirst;
	while (tnode!=0) {		
		//printf("->>mainloop: %f %f\n",(float)tnode->x,(float)tnode->y);
		if (tnode->newhere) TB->BProject(tnode);
		DrawText(GLUT_BITMAP_HELVETICA_10, tnode->text,tnode->r, tnode->g, tnode->b, tnode->sx,tnode->sy+float(tnode->timer)/(SHeight));   
		tnode=tnode->pNext;
	}
	
	isdrawing=0;	
	
	//Punkt auf interessante stelle setzen
	int x=82;
	int y=17;			    
	
	glPushMatrix();
	glTranslatef(0.5+x-fieldposx, Landscape->gethigh(x, y) * Highscale,0.5+y-fieldposy);					
	glCallList(hcm[17]->ObjectList[zoom]);
	glPopMatrix();	
    
	glEnable(GL_TEXTURE_2D);
	if (Polys) {
		for (int i=Kxbegin;i<Kxend;i++) {
			for (int l=Kybegin;l<Kyend;l++) {				
				if (inview(i,l)) {
					//polys zeichnen					
					lg1[0] = Landscape->col[i + fieldposx][l + fieldposy][0][0];
					lg1[1] = Landscape->col[i + fieldposx][l + fieldposy][0][1];
					lg1[2] = Landscape->col[i + fieldposx][l + fieldposy][0][2];
					lg1[3] = Landscape->col[i + fieldposx][l + fieldposy][0][3];
					lg2[0] = Landscape->col[i + fieldposx][l + fieldposy][1][0];
					lg2[1] = Landscape->col[i + fieldposx][l + fieldposy][1][1];
					lg2[2] = Landscape->col[i + fieldposx][l + fieldposy][1][2];
					lg2[3] = Landscape->col[i + fieldposx][l + fieldposy][1][3];
					lg3[0] = Landscape->col[i + fieldposx][l + fieldposy][2][0];
					lg3[1] = Landscape->col[i + fieldposx][l + fieldposy][2][1];
					lg3[2] = Landscape->col[i + fieldposx][l + fieldposy][2][2];
					lg3[3] = Landscape->col[i + fieldposx][l + fieldposy][2][3];
					lg4[0] = Landscape->col[i + fieldposx][l + fieldposy][3][0];
					lg4[1] = Landscape->col[i + fieldposx][l + fieldposy][3][1];
					lg4[2] = Landscape->col[i + fieldposx][l + fieldposy][3][2];
					lg4[3] = Landscape->col[i + fieldposx][l + fieldposy][3][3];									
					
					
					lg1[0] = 1;
					lg1[1] = 1;
					lg1[2] = 1;
					lg1[3] = 1;
					glMaterialfv (GL_FRONT, GL_DIFFUSE, lg1);
					
					if (Landscape->watermask[i + fieldposx][l + fieldposy][0])
						glBindTexture(GL_TEXTURE_2D, texture[1]);
					else glBindTexture(GL_TEXTURE_2D, texture[0]);						
					glBegin (GL_TRIANGLES);
						//glColor3f(0.0f,0.4f,0.0f);
						//glMaterialfv (GL_FRONT, GL_DIFFUSE, lg1);
						glNormal3fv (Landscape->gethighnorm(i + fieldposx,l + fieldposy,0));
						glTexCoord2f(0.0f, 0.0f);glVertex3f(i, Landscape->gethigh(i + fieldposx, l + fieldposy) * Highscale, l);
						glTexCoord2f(1.0f, 0.0f);glVertex3f(i+1, Landscape->gethigh(i + 1 + fieldposx, l + fieldposy) * Highscale, l);
						glTexCoord2f(0.5f, 0.5f);glVertex3f(i+0.5, Landscape->getmphight1 (i + fieldposx, l + fieldposy) * Highscale, l+0.5);			
					glEnd();
					if (Landscape->watermask[i + fieldposx][l + fieldposy][1])
						glBindTexture(GL_TEXTURE_2D, texture[1]);
					else glBindTexture(GL_TEXTURE_2D, texture[0]);
					glBegin (GL_TRIANGLES);
						//glColor3f(0.0f,0.4f,0.0f);
						//glMaterialfv (GL_FRONT, GL_DIFFUSE, lg2);
						glNormal3fv (Landscape->gethighnorm(i + fieldposx,l + fieldposy,1));				
						glTexCoord2f(1.0f, 0.0f);glVertex3f(i+1, Landscape->gethigh(i + 1 + fieldposx, l + fieldposy) * Highscale, l);
						glTexCoord2f(1.0f, 1.0f);glVertex3f(i+1, Landscape->gethigh(i + 1 + fieldposx, l + 1 + fieldposy) * Highscale, l+1);
						glTexCoord2f(0.5f, 0.5f);glVertex3f(i+0.5, Landscape->getmphight2 (i + fieldposx, l + fieldposy) * Highscale, l+0.5);	
					glEnd();
					if (Landscape->watermask[i + fieldposx][l + fieldposy][2])
						glBindTexture(GL_TEXTURE_2D, texture[1]);
					else glBindTexture(GL_TEXTURE_2D, texture[0]);
					glBegin (GL_TRIANGLES);
						//glColor3f(0.0f,0.4f,0.0f);
						//glMaterialfv (GL_FRONT, GL_DIFFUSE, lg3);
						glNormal3fv (Landscape->gethighnorm(i + fieldposx,l + fieldposy,2));				
						glTexCoord2f(1.0f, 1.0f);glVertex3f(i+1, Landscape->gethigh(i + 1 + fieldposx, l + 1 + fieldposy) * Highscale, l+1);
						glTexCoord2f(0.0f, 1.0f);glVertex3f(i, Landscape->gethigh(i + fieldposx, l + 1 + fieldposy) * Highscale, l+1);
						glTexCoord2f(0.5f, 0.5f);glVertex3f(i+0.5, Landscape->getmphight3 (i + fieldposx, l + fieldposy) * Highscale, l+0.5);	
					glEnd();
					if (Landscape->watermask[i + fieldposx][l + fieldposy][3])
						glBindTexture(GL_TEXTURE_2D, texture[1]);
					else glBindTexture(GL_TEXTURE_2D, texture[0]);
					glBegin (GL_TRIANGLES);
						//glColor3f(0.0f,0.4f,0.0f);
						//glMaterialfv (GL_FRONT, GL_DIFFUSE, lg4);
						glNormal3fv (Landscape->gethighnorm(i + fieldposx,l + fieldposy,3));				
						glTexCoord2f(0.0f, 0.0f);glVertex3f(i, Landscape->gethigh(i + fieldposx, l + fieldposy) * Highscale, l);
						glTexCoord2f(0.5f, 0.5f);glVertex3f(i+0.5, Landscape->getmphight4(i + fieldposx, l + fieldposy) * Highscale, l+0.5);	
						glTexCoord2f(0.0f, 1.0f);glVertex3f(i, Landscape->gethigh (i + fieldposx, l + 1 + fieldposy) * Highscale, l+1);			
					glEnd();
							
					}
				}
			}
		}
					
					
		//glDisable(GL_LIGHTING);
		
		glColor3f(1.0f,1.0f,1.0f);
		glMaterialfv (GL_FRONT, GL_SMOOTH, lg1);
		for (int i=Kxbegin;i<Kxend;i++) {
			for (int l=Kybegin;l<Kyend;l++) {				
				if (inview(i,l)) {		
					
					
					
					ONODE *oNode = prv->objpointerfirst[i + fieldposx][l + fieldposy];
					while (oNode!=0) {						
						glPushMatrix();
			    		glTranslatef(i,oNode->hight*Highscale,l);  		
						glCallList(oNode->Objecttype->ObjectList[zoom]);
						glPopMatrix();
						oNode=oNode->pNext;
					}
					// Schienen Zeichnen 										
					RNODE *rNode = RN->RailTrackfirst[i + fieldposx][l + fieldposy];
					while (rNode!=0) {
						glPushMatrix();
						glTranslatef(i,rNode->hight*Highscale,l);  		
						if (rNode->tracktype==1)  {
							glPushMatrix();					
							glCallList(hcm[0]->ObjectList[zoom]);					
							glTranslatef(0.25,0,0.25);  		
							glRotatef(-45,0,1,0);
							if (rNode->signal1) if (!rNode->signal1state) glCallList(hcm[10]->ObjectList[zoom]); else glCallList(hcm[11]->ObjectList[zoom]);
							if (rNode->signal2) if (!rNode->signal2state) glCallList(hcm[12]->ObjectList[zoom]); else glCallList(hcm[13]->ObjectList[zoom]);
							glPopMatrix();
						}
						if (rNode->tracktype==2) {
							glPushMatrix();
							glCallList(hcm[1]->ObjectList[zoom]);					
							glTranslatef(0.75,0,0.25);  		
							glRotatef(45,0,1,0);
							if (rNode->signal1) if (!rNode->signal1state) glCallList(hcm[10]->ObjectList[zoom]); else glCallList(hcm[11]->ObjectList[zoom]);
							if (rNode->signal2) if (!rNode->signal2state) glCallList(hcm[12]->ObjectList[zoom]); else glCallList(hcm[13]->ObjectList[zoom]);					
							glPopMatrix();
						}
						if (rNode->tracktype==3) {
							glPushMatrix();
							glCallList(hcm[2]->ObjectList[zoom]);					
							glTranslatef(0.75,0,0.75);  		
							glRotatef(-45,0,1,0);
							if (rNode->signal1) if (!rNode->signal1state) glCallList(hcm[10]->ObjectList[zoom]); else glCallList(hcm[11]->ObjectList[zoom]);
							if (rNode->signal2) if (!rNode->signal2state) glCallList(hcm[12]->ObjectList[zoom]); else glCallList(hcm[13]->ObjectList[zoom]);					
							glPopMatrix();
						}
						if (rNode->tracktype==4) {
							glPushMatrix();
							glCallList(hcm[3]->ObjectList[zoom]);					
							glTranslatef(0.25,0,0.75);  		
							glRotatef(45,0,1,0);
							if (rNode->signal1) if (!rNode->signal1state) glCallList(hcm[10]->ObjectList[zoom]); else glCallList(hcm[11]->ObjectList[zoom]);
							if (rNode->signal2) if (!rNode->signal2state) glCallList(hcm[12]->ObjectList[zoom]); else glCallList(hcm[13]->ObjectList[zoom]);										
							glPopMatrix();
						}
						if (rNode->tracktype==5) {
							glPushMatrix();
							glCallList(hcm[4]->ObjectList[zoom]);					
							if (rNode->bahnsteig) glCallList(hcm[14]->ObjectList[zoom]);
							glTranslatef(0.5,0,0.5);  		
							glRotatef(90,0,1,0);
							if (rNode->signal1) if (!rNode->signal1state) glCallList(hcm[10]->ObjectList[zoom]); else glCallList(hcm[11]->ObjectList[zoom]);					
							if (rNode->signal2) if (!rNode->signal2state) glCallList(hcm[12]->ObjectList[zoom]); else glCallList(hcm[13]->ObjectList[zoom]);										
							glPopMatrix();
						}
						if (rNode->tracktype==6) {
							glPushMatrix();
							glCallList(hcm[5]->ObjectList[zoom]);
							if (rNode->bahnsteig) glCallList(hcm[15]->ObjectList[zoom]);
							glTranslatef(0.5,0,0.5);  		
							if (rNode->signal1) if (!rNode->signal1state) glCallList(hcm[10]->ObjectList[zoom]); else glCallList(hcm[11]->ObjectList[zoom]);
							if (rNode->signal2) if (!rNode->signal2state) glCallList(hcm[12]->ObjectList[zoom]); else glCallList(hcm[13]->ObjectList[zoom]);															
							glPopMatrix();
						}
						if (rNode->tracktype==7) glCallList(hcm[6]->ObjectList[zoom]);					
						if (rNode->tracktype==8) glCallList(hcm[7]->ObjectList[zoom]);					
						if (rNode->tracktype==9) glCallList(hcm[8]->ObjectList[zoom]);					
						if (rNode->tracktype==10) glCallList(hcm[9]->ObjectList[zoom]);					
						
						glPopMatrix();
						rNode=rNode->pNext;										
					}
				}
			}
		
	}
	
	if (Grid) {
		glDisable(GL_LIGHTING);
		for (int i=Kxbegin;i<Kxend;i++) {
			for (int l=Kybegin;l<Kyend;l++) {
				if (inview(i,l)) {
				glBegin(GL_LINES);	
					//glMaterialfv (GL_FRONT, GL_DIFFUSE, lg);		
					glColor3f(0.0f,0.4f,0.0f);
					glVertex3f(i, Landscape->gethigh(i + fieldposx, l + fieldposy) * Highscale+0.02, l);
					glVertex3f(i+1, Landscape->gethigh (i + 1 + fieldposx, l + fieldposy) * Highscale+0.02, l);
				glEnd();
				glBegin(GL_LINES);	
					glColor3f(0.0f,0.4f,0.0f);
					glVertex3f(i, Landscape->gethigh (i + fieldposx, l + fieldposy) * Highscale+0.02, l);
					glVertex3f(i, Landscape->gethigh (i + fieldposx, l + 1 + fieldposy) * Highscale+0.02, l+1);
				glEnd();
				}
			}
		}
	}

	//Zge zeichnen
	glEnable(GL_LIGHTING);
	ZUGNODE *zNode = prv->firstzug;
	while (zNode!=0) {				
		//if (inview(zNode->zug.x-fieldposx,zNode->zug.y-fieldposy)) {			
		if (1) {
			int tl=zNode->zug.trainlength;
			int z=0;								
			int anfang, ende,mitte;
			for (int i=0;i<zNode->zug.wagoncounter;i++) {
				anfang=zNode->zug.wag[i]->axevorn;
				ende=zNode->zug.wag[i]->length-zNode->zug.wag[i]->axevorn-zNode->zug.wag[i]->axehinten;
				mitte=zNode->zug.wag[i]->length/2;
				
				glPushMatrix();
				if (i>0) z+=zNode->zug.wag[i-1]->length;					
				glTranslatef(
					(zNode->zug.kx[(zNode->zug.punktpointer+anfang+z)%tl]-fieldposx+zNode->zug.kx[(zNode->zug.punktpointer+ende+z)%tl]-fieldposx)/2,
					(zNode->zug.kh[(zNode->zug.punktpointer+mitte+z)%tl]+0.1)*Highscale, //0.1 fr schienenhhe
					(zNode->zug.ky[(zNode->zug.punktpointer+anfang+z)%tl]-fieldposy+zNode->zug.ky[(zNode->zug.punktpointer+ende+z)%tl]-fieldposy)/2);  		
				float a=atan((float)(zNode->zug.ky[(zNode->zug.punktpointer+anfang+z)%tl]-zNode->zug.ky[(zNode->zug.punktpointer+ende+z)%tl])/
					(float)(zNode->zug.kx[(zNode->zug.punktpointer+anfang+z)%tl]-zNode->zug.kx[(zNode->zug.punktpointer+ende+z)%tl]));
				a=-a*(180/3.141)+180;
				float dist=sqrt(((zNode->zug.kx[(zNode->zug.punktpointer+anfang+z)%tl]
						 -zNode->zug.kx[(zNode->zug.punktpointer+ende+z)%tl])*
				(zNode->zug.kx[(zNode->zug.punktpointer+anfang+z)%tl]
						 -zNode->zug.kx[(zNode->zug.punktpointer+ende+z)%tl]))+					
						((zNode->zug.ky[(zNode->zug.punktpointer+anfang+z)%tl]
						-zNode->zug.ky[(zNode->zug.punktpointer+ende+z)%tl])*
				(zNode->zug.ky[(zNode->zug.punktpointer+anfang+z)%tl]
						-zNode->zug.ky[(zNode->zug.punktpointer+ende+z)%tl])));
				float b=atan((float)(zNode->zug.kh[(zNode->zug.punktpointer+anfang+z)%tl]-zNode->zug.kh[(zNode->zug.punktpointer+ende+z)%tl])*Highscale/dist);	
				if (zNode->zug.kx[(zNode->zug.punktpointer+anfang+z)%tl]-zNode->zug.kx[(zNode->zug.punktpointer+ende+z)%tl]>=0) a=a-180;
				b=b*(180/3.141);
				glRotatef(a,0.0f,1.0f,0.0f);	
				glRotatef(b,0.0f,0.0f,1.0f);					
				int fulload=0;
				if (zNode->zug.wag[i]->wagon) if (zNode->zug.loadamount[i]>0) fulload=3;
				glCallList(zNode->zug.wag[i]->ObjectList[zoom+fulload]);					
				glPopMatrix();
			}
			
			glPushMatrix();
			glTranslatef(0.5+zNode->zug.x-fieldposx,zNode->zug.rh*Highscale,0.5+zNode->zug.y-fieldposy);  		
			glColor3f(0.3,0.3,0.3);
			glCallList(hcm[17]->ObjectList[zoom]);
			glPopMatrix();
		}
			zNode=zNode->pNext;
		
	}
	
	glDisable(GL_LIGHTING);
// Gewhlten Zug Kennzeichnen
			if (selectetzug) {
				glPushMatrix();				
			    glTranslatef(selectetzug->zug.x-fieldposx+0.5,Landscape->Bgethigh(selectetzug->zug.x,selectetzug->zug.y)*Highscale,selectetzug->zug.y-fieldposy+0.5);  		
				glColor3f(1.0,0.0,0.0);
				glCallList(hcm[17]->ObjectList[zoom]);
				glPopMatrix();
				if (selectetzug->zug.zielnode!=0) {
				glPushMatrix();
				glBegin(GL_LINES);	
						glColor3f(0.0f,0.5f,1.0f);
						glVertex3f(selectetzug->zug.x-fieldposx+0.5, Landscape->Bgethigh(selectetzug->zug.x,selectetzug->zug.y)*Highscale+0.5, selectetzug->zug.y-fieldposy+0.5);
						glVertex3f( selectetzug->zug.zielnode->x-fieldposx+0.5, 
									Landscape->Bgethigh(selectetzug->zug.zielnode->x,selectetzug->zug.zielnode->y)*Highscale+0.5, 
									selectetzug->zug.zielnode->y-fieldposy+0.5);						
					glEnd();					
				glPopMatrix();
				}
			}
			
// Marschtabelle fr Zge anzeigen;
		if (showfahrplaene) {
			
			ZUGNODE *zugNode=prv->firstzug;
			while (zugNode!=0) {
			if (!workingonmarschtabelle) {
				glPushMatrix();
				MARSCHTABELLENNODE *mNode=zugNode->zug.marschtabellennodefirst;
				if (mNode!=0)
				while (mNode->pNext!=0) {					
					glBegin(GL_LINES);	
						glColor3f(1.0f,0.0f,0.0f);
						glVertex3f(mNode->SuperNode->x-fieldposx+0.5, 0.2+mNode->SuperNode->track->hight * Highscale+0.02, mNode->SuperNode->y-fieldposy+0.5);
						glVertex3f(mNode->pNext->SuperNode->x-fieldposx+0.5, 0.2+mNode->pNext->SuperNode->track->hight * Highscale+0.02, mNode->pNext->SuperNode->y-fieldposy+0.5);						
					glEnd();
					mNode=mNode->pNext;
				}
				glPopMatrix();
				
			}
			zugNode=zugNode->pNext;
		}	
//Fahrplan fr Zug anzeigen
		zugNode=prv->firstzug;
			while (zugNode!=0) {
			
				glPushMatrix();
				FAHRPLANNODE *FNode=zugNode->zug.fahrplannodefirst;
				if (FNode!=0) {								
				while (FNode->pNext!=0) {						
					glBegin(GL_LINES);	
						glColor3f(0.0f,1.0f,1.0f);
						if (FNode->target==0) glVertex3f(FNode->SuperNode->x-fieldposx+0.5, 0.2+FNode->SuperNode->track->hight * Highscale+0.02, FNode->SuperNode->y-fieldposy+0.5);
						if (FNode->target==1) glVertex3f(FNode->tsNode->x-fieldposx+0.5, 0.2+FNode->tsNode->hight * Highscale+0.02, FNode->tsNode->y-fieldposy+0.5);	
						if (FNode->pNext->target==0) glVertex3f(FNode->pNext->SuperNode->x-fieldposx+0.5, 0.2+FNode->pNext->SuperNode->track->hight * Highscale+0.02, FNode->pNext->SuperNode->y-fieldposy+0.5);						
						if (FNode->pNext->target==1) glVertex3f(FNode->pNext->tsNode->x-fieldposx+0.5, 0.2+FNode->pNext->tsNode->hight * Highscale+0.02, FNode->pNext->tsNode->y-fieldposy+0.5);						
					glEnd();
					FNode=FNode->pNext;
				}				
						
					glBegin(GL_LINES);			
						glColor3f(0.0f,1.0f,1.0f);
						if (FNode->target==0) glVertex3f(FNode->SuperNode->x-fieldposx+0.5, 0.2+FNode->SuperNode->track->hight * Highscale+0.02, FNode->SuperNode->y-fieldposy+0.5);
						if (FNode->target==1)glVertex3f(FNode->tsNode->x-fieldposx+0.5, 0.2+FNode->tsNode->hight * Highscale+0.02, FNode->tsNode->y-fieldposy+0.5);	
						if (zugNode->zug.fahrplannodefirst->target==0) glVertex3f(zugNode->zug.fahrplannodefirst->SuperNode->x-fieldposx+0.5, 0.2+zugNode->zug.fahrplannodefirst->SuperNode->track->hight * Highscale+0.02, zugNode->zug.fahrplannodefirst->SuperNode->y-fieldposy+0.5);						
						if (zugNode->zug.fahrplannodefirst->target==1)	glVertex3f(zugNode->zug.fahrplannodefirst->tsNode->x-fieldposx+0.5, 0.2+zugNode->zug.fahrplannodefirst->tsNode->hight * Highscale+0.02, zugNode->zug.fahrplannodefirst->tsNode->y-fieldposy+0.5);						
					glEnd();	
				glPopMatrix();
			}
			zugNode=zugNode->pNext;
		}
	}
  //Signale Schaltungen Anzeigen
if (showsignalnetwork) {
			glDisable(GL_LIGHTING);
			SUPERNODE *sNode = RN->supernodelistfirst;
			while (sNode!=0) {
				for (int k=0;k<4;k++) {
					if (sNode->signallistbegin[k]!=0) {
						SIGNALSTRUCT *eNode=sNode->signallistbegin[k];
						while (eNode!=0) {
						glBegin(GL_LINES);
						if (k==0) glColor3f(1.0,0.0,1.0);					
						if (k==1) glColor3f(1.0,1.0,1.0);					
						if (k==2) glColor3f(0.0,0.0,1.0);					
						if (k==3) glColor3f(1.0,0.0,0.0);					
							glVertex3f(sNode->x-fieldposx+0.5,0.225+sNode->track->hight*Highscale,sNode->y-fieldposy+0.5);
						if (eNode->indir==0) 	
							glVertex3f(eNode->sNode->x-fieldposx+0.75,0.2+eNode->sNode->track->hight*Highscale,eNode->sNode->y-fieldposy+0.5);
						if (eNode->indir==1) 	
							glVertex3f(eNode->sNode->x-fieldposx+0.5,0.2+eNode->sNode->track->hight*Highscale,eNode->sNode->y-fieldposy+0.75);					
						if (eNode->indir==2) 	
							glVertex3f(eNode->sNode->x-fieldposx+0.25,0.2+eNode->sNode->track->hight*Highscale,eNode->sNode->y-fieldposy+0.5);					
						if (eNode->indir==3) 	
							glVertex3f(eNode->sNode->x-fieldposx+0.5,0.2+eNode->sNode->track->hight*Highscale,eNode->sNode->y-fieldposy+0.25);					
						glEnd();
							eNode=eNode->pNext;
						}
					}
				}
				sNode=sNode->pNext;
			}
		}
		
  // Supernodes Anzeigen

		if (showsupernodenetwork) {
			glDisable(GL_LIGHTING);
			SUPERNODE *sNode = RN->supernodelistfirst;
			while (sNode!=0) {
				glPushMatrix();	
					glColor3f(1.0,1.0,1.0);										
					glBegin(GL_LINES);							
						glVertex3f(sNode->x-fieldposx+0.5,sNode->track->hight*Highscale,sNode->y-fieldposy+0.5);
						glVertex3f(sNode->x-fieldposx+0.5,0.6+sNode->track->hight*Highscale,sNode->y-fieldposy+0.5);						
					glEnd();			
					
				glPopMatrix();
				glPushMatrix();
						
				
				
					glBegin(GL_LINES);
						if (sNode->gesperrt[0]) glColor3f(1.0,0.0,0.0); else glColor3f(0.0,1.0,0.0);																
						glVertex3f(sNode->x-fieldposx+0.5,0.6+sNode->track->hight*Highscale,sNode->y-fieldposy+0.5);
						glVertex3f(sNode->x-fieldposx+0.75,0.6+sNode->track->hight*Highscale,sNode->y-fieldposy+0.5);					
					glEnd();
					glBegin(GL_LINES);
						if (sNode->gesperrt[1]) glColor3f(1.0,0.0,0.0); else glColor3f(0.0,1.0,0.0);																
						glVertex3f(sNode->x-fieldposx+0.5,0.6+sNode->track->hight*Highscale,sNode->y-fieldposy+0.5);
						glVertex3f(sNode->x-fieldposx+0.5,0.6+sNode->track->hight*Highscale,sNode->y-fieldposy+0.75);					
					glEnd();
					glBegin(GL_LINES);
						if (sNode->gesperrt[2]) glColor3f(1.0,0.0,0.0); else glColor3f(0.0,1.0,0.0);																
						glVertex3f(sNode->x-fieldposx+0.5,0.6+sNode->track->hight*Highscale,sNode->y-fieldposy+0.5);
						glVertex3f(sNode->x-fieldposx+0.25,0.6+sNode->track->hight*Highscale,sNode->y-fieldposy+0.5);					
					glEnd();
					glBegin(GL_LINES);
						if (sNode->gesperrt[3]) glColor3f(1.0,0.0,0.0); else glColor3f(0.0,1.0,0.0);																
						glVertex3f(sNode->x-fieldposx+0.5,0.6+sNode->track->hight*Highscale,sNode->y-fieldposy+0.5);
						glVertex3f(sNode->x-fieldposx+0.5,0.6+sNode->track->hight*Highscale,sNode->y-fieldposy+0.25);					
					glEnd();
				
				
				for (int k=0;k<4;k++) {
					
					
					
					if (sNode->sdir[k]==0) {
					glBegin(GL_LINES);
						glColor3f(1.0,1.0,0.0);										
						
						glVertex3f(sNode->x-fieldposx+0.5,(float)(k)/10+0.15+sNode->track->hight*Highscale,sNode->y-fieldposy+0.5);
						glVertex3f(sNode->x-fieldposx+0.75,(float)(k)/10+0.15+sNode->track->hight*Highscale,sNode->y-fieldposy+0.5);					
					glEnd();
					}
					if (sNode->sdir[k]==1) {
						glBegin(GL_LINES);
					glColor3f(1.0,1.0,0.0);					
						
						glVertex3f(sNode->x-fieldposx+0.5,(float)(k)/10+0.15+sNode->track->hight*Highscale,sNode->y-fieldposy+0.5);
						glVertex3f(sNode->x-fieldposx+0.5,(float)(k)/10+0.15+sNode->track->hight*Highscale,sNode->y-fieldposy+0.75);					
					glEnd();
					}
					if (sNode->sdir[k]==2) {
						glBegin(GL_LINES);
					glColor3f(1.0,1.0,0.0);	
						
						glVertex3f(sNode->x-fieldposx+0.5,(float)(k)/10+0.15+sNode->track->hight*Highscale,sNode->y-fieldposy+0.5);
						glVertex3f(sNode->x-fieldposx+0.25,(float)(k)/10+0.15+sNode->track->hight*Highscale,sNode->y-fieldposy+0.5);					
					glEnd();
					}
					if (sNode->sdir[k]==3) {
						glBegin(GL_LINES);
					glColor3f(1.0,1.0,0.0);	
						
						glVertex3f(sNode->x-fieldposx+0.5,(float)(k)/10+0.15+sNode->track->hight*Highscale,sNode->y-fieldposy+0.5);
						glVertex3f(sNode->x-fieldposx+0.5,(float)(k)/10+0.15+sNode->track->hight*Highscale,sNode->y-fieldposy+0.25);					
					glEnd();
					}
					
				if (sNode->dir[k][0]) {
					glBegin(GL_LINES);	
					glColor3f(0.0,0.0,1.0);	
					if (!sNode->deathend[0]) {
						glVertex3f(sNode->x-fieldposx+1.0,(float)(k)/10+0.2+sNode->track->hight*Highscale,sNode->y-fieldposy+0.5);
						glVertex3f(sNode->dir[k][0]->x-fieldposx+0.5,(float)(k)/10+0.0+sNode->dir[k][0]->track->hight*Highscale,sNode->dir[k][0]->y-fieldposy+0.5);
					}
					glColor3f(1.0,1.0,1.0);					
						if (sNode->deathend[0]) glColor3f(1.0,0.0,0.0);						
						glVertex3f(sNode->x-fieldposx+0.5,(float)(k)/10+0.2+sNode->track->hight*Highscale,sNode->y-fieldposy+0.5);
						glVertex3f(sNode->x-fieldposx+1.0,(float)(k)/10+0.2+sNode->track->hight*Highscale,sNode->y-fieldposy+0.5);					
					glEnd();
				}
				if (sNode->dir[k][1]) {
					glBegin(GL_LINES);	
					if (!sNode->deathend[1]) {
						glColor3f(0.0,0.0,1.0);	
						glVertex3f(sNode->x-fieldposx+0.5,(float)(k)/10+0.2+sNode->track->hight*Highscale,sNode->y-fieldposy+1.0);
						glVertex3f(sNode->dir[k][1]->x-fieldposx+0.5,(float)(k)/10+0.0+sNode->dir[k][1]->track->hight*Highscale,sNode->dir[k][1]->y-fieldposy+0.5);
					}
					glColor3f(1.0,1.0,1.0);						
						if (sNode->deathend[1]) glColor3f(1.0,0.0,0.0);						
						glVertex3f(sNode->x-fieldposx+0.5,(float)(k)/10+0.2+sNode->track->hight*Highscale,sNode->y-fieldposy+0.5);
						glVertex3f(sNode->x-fieldposx+0.5,(float)(k)/10+0.2+sNode->track->hight*Highscale,sNode->y-fieldposy+1.0);
					
					glEnd();
				}
				if (sNode->dir[k][2]) {
					glBegin(GL_LINES);	
					if (!sNode->deathend[2]) {
						glColor3f(0.0,0.0,1.0);	
						glVertex3f(sNode->x-fieldposx,(float)(k)/10+0.2+sNode->track->hight*Highscale,sNode->y-fieldposy+0.5);
						glVertex3f(sNode->dir[k][2]->x-fieldposx+0.5,(float)(k)/10+0.0+sNode->dir[k][2]->track->hight*Highscale,sNode->dir[k][2]->y-fieldposy+0.5);
					}
					glBegin(GL_LINES);	
						glColor3f(1.0,1.0,1.0);					
						if (sNode->deathend[2]) glColor3f(1.0,0.0,0.0);						
						glVertex3f(sNode->x-fieldposx+0.5,(float)(k)/10+0.2+sNode->track->hight*Highscale,sNode->y-fieldposy+0.5);
						glVertex3f(sNode->x-fieldposx,(float)(k)/10+0.2+sNode->track->hight*Highscale,sNode->y-fieldposy+0.5);
					glEnd();
				}
				if (sNode->dir[k][3]) {
					glBegin(GL_LINES);		
					glBegin(GL_LINES);	
						if (!sNode->deathend[3]) {
						glColor3f(0.0,0.0,1.0);	
						glVertex3f(sNode->x-fieldposx+0.5,(float)(k)/10+0.2+sNode->track->hight*Highscale,sNode->y-fieldposy);
						glVertex3f(sNode->dir[k][3]->x-fieldposx+0.5,(float)(k)/10+0.0+sNode->dir[k][3]->track->hight*Highscale,sNode->dir[k][3]->y-fieldposy+0.5);
						}
					glColor3f(1.0,1.0,1.0);	
						if (sNode->deathend[3]) glColor3f(1.0,0.0,0.0);											
						glVertex3f(sNode->x-fieldposx+0.5,(float)(k)/10+0.2+sNode->track->hight*Highscale,sNode->y-fieldposy+0.5);
						glVertex3f(sNode->x-fieldposx+0.5,(float)(k)/10+0.2+sNode->track->hight*Highscale,sNode->y-fieldposy);
					glEnd();
				}
			}
				glPopMatrix();
				sNode=sNode->pNext;
			}
		}
	

//Depots Zeichen
	glPushMatrix();		
	glEnable(GL_LIGHTING);		
	DepotNodeClass *dpNode=RN->depotlistfirst;
	while (dpNode!=0) {
		glPushMatrix();
		glTranslatef(dpNode->xpos-fieldposx,dpNode->hight*Highscale,dpNode->ypos-fieldposy);  		
		glCallList(hcm[36]->ObjectList[zoom]);
		glPopMatrix();
		dpNode=dpNode->pNext;
	}
//Bahnhfe zeichnen


  
	glPushMatrix();		
	glEnable(GL_LIGHTING);		
	TSNODE *tsNode=RN->firsttrainstation;
	while (tsNode!=0) {
		if (inview(tsNode->x-fieldposx,tsNode->y-fieldposy)) {
			glPushMatrix();
			glTranslatef(tsNode->x-fieldposx,tsNode->hight*Highscale,tsNode->y-fieldposy);  		
			glCallList(hcm[16]->ObjectList[zoom]);
			glPopMatrix();
		}
		tsNode=tsNode->pNext;
	}
	glPopMatrix();
  
	
//Industrie <-> TS verbindungen zeigen
	
	
	
	TSNODE *ts2Node=RN->firsttrainstation;
	while (ts2Node!=0) {
		HONODE *hoNode=ts2Node->connectetindustriesfirst;
		while (hoNode!=0) {
			glBegin(GL_LINES);	
				glColor3f(0.5,0.0,0.0);								
				glVertex3f(ts2Node->x-fieldposx+0.5,1+ts2Node->hight*Highscale,ts2Node->y-fieldposy+0.5);
				glVertex3f(hoNode->oNode->x-fieldposx,0.5+hoNode->oNode->hight*Highscale,hoNode->oNode->y-fieldposy);
			glEnd();			
			hoNode=hoNode->pNext;
		}
		ts2Node=ts2Node->pNext;
	}
	
	

  
  glEnable(GL_LIGHTING);	
		glLoadIdentity();				// Reset The View
		glTranslatef(0.0f,-0.5f,-10.0f);
		glRotatef(30,1.0f,0.0f,0.0f);	
  		glRotatef(45,0.0f,1.0f,0.0f);	
 
	
	//Cursor Zeichnen
if (editterrain) {
glDisable(GL_LIGHTING);	
	glLoadIdentity();				// Reset The View
		glTranslatef(0.0f,-0.5f,-10.0f);
		glRotatef(30,1.0f,0.0f,0.0f);	
  		glRotatef(45,0.0f,1.0f,0.0f);
		glPushMatrix();
		glTranslatef(cfx,Landscape->gethigh (cfx+fieldposx,cfy+fieldposy) * Highscale,cfy);  		
		glColor3f(1.0,0.0,0.0);
		glCallList(hcm[17]->ObjectList[zoom]);
		glPopMatrix();
}

//trackvorschau oder pfeiler oder signalsatzkstchen oder depotkstchen oder erasekstchen bahnhfe zeichnen
if (laytrack||pillarbuild||signalbuild||depotbuild||deletetrack||buildtrainstation) {
glDisable(GL_LIGHTING);	
	glLoadIdentity();				// Reset The View
		glTranslatef(0.0f,-0.5f,-10.0f);
		glRotatef(30,1.0f,0.0f,0.0f);	
  		glRotatef(45,0.0f,1.0f,0.0f);
		if (laytrack) {
			glPushMatrix();
			int tr=fitTrack(ckx+fieldposx,cky+fieldposy,tracktype);
			glTranslatef(ckx,Landscape->getmphigh(ckx+fieldposx,cky+fieldposy) * Highscale,cky);  							
			if (tr>0) glCallList(hcm[tr-1]->ObjectList[zoom]);					
		}
		glPopMatrix();
		glPushMatrix();
		glColor3f(1.0,0.0,0.0);
		glBegin(GL_LINE_STRIP);		
				glVertex3f(ckx, 0.04+Landscape->gethigh(ckx + fieldposx, cky + fieldposy) * Highscale+0.02, cky);
				glVertex3f(ckx+1,0.04+ Landscape->gethigh(ckx+1 + fieldposx, cky + fieldposy) * Highscale+0.02, cky);
				glVertex3f(ckx+1,0.04+ Landscape->gethigh(ckx+1 + fieldposx, cky+1 + fieldposy) * Highscale+0.02, cky+1);
				glVertex3f(ckx,0.04+ Landscape->gethigh(ckx + fieldposx, cky +1+ fieldposy) * Highscale+0.02, cky+1);
				glVertex3f(ckx,0.04+ Landscape->gethigh(ckx + fieldposx, cky + fieldposy) * Highscale+0.02, cky);
		glEnd();	
		glPopMatrix();
}
//pillargrid zeichnen
if (pillarbuild&&pillargrid) {
	glDisable(GL_LIGHTING);	
	glLoadIdentity();				// Reset The View
		glTranslatef(0.0f,-0.5f,-10.0f);
		glRotatef(30,1.0f,0.0f,0.0f);	
  		glRotatef(45,0.0f,1.0f,0.0f);
	glColor3f(1.0,0.0,0.0);
	glBegin(GL_LINE_STRIP);		
			glVertex3f(pillarx, 0.04+(-pillarhight+Landscape->gethigh(pillarx + fieldposx, pillary + fieldposy)) * Highscale+0.02, pillary);
			glVertex3f(pillarx+1,0.04+(-pillarhight+ Landscape->gethigh(pillarx+1 + fieldposx, pillary + fieldposy)) * Highscale+0.02, pillary);
			glVertex3f(pillarx+1,0.04+(-pillarhight+ Landscape->gethigh(pillarx+1 + fieldposx, pillary+1 + fieldposy)) * Highscale+0.02, pillary+1);
			glVertex3f(pillarx,0.04+(-pillarhight+ Landscape->gethigh(pillarx + fieldposx, pillary +1+ fieldposy)) * Highscale+0.02, pillary+1);
			glVertex3f(pillarx,0.04+(-pillarhight+ Landscape->gethigh(pillarx + fieldposx, pillary + fieldposy)) * Highscale+0.02, pillary);
	glEnd();	
	glBegin(GL_LINES);	
		glVertex3f(ckx, 0.04+Landscape->gethigh(ckx + fieldposx, cky + fieldposy) * Highscale+0.02, cky);
		glVertex3f(pillarx, 0.04+(-pillarhight+Landscape->gethigh(pillarx + fieldposx, pillary + fieldposy)) * Highscale+0.02, pillary);
		glVertex3f(ckx+1,0.04+ Landscape->gethigh(ckx+1 + fieldposx, cky + fieldposy) * Highscale+0.02, cky);
		glVertex3f(pillarx+1,0.04+(-pillarhight+ Landscape->gethigh(pillarx+1 + fieldposx, pillary + fieldposy)) * Highscale+0.02, pillary);		
		glVertex3f(ckx+1,0.04+ Landscape->gethigh(ckx+1 + fieldposx, cky+1 + fieldposy) * Highscale+0.02, cky+1);
		glVertex3f(pillarx+1,0.04+(-pillarhight+ Landscape->gethigh(pillarx+1 + fieldposx, pillary+1 + fieldposy)) * Highscale+0.02, pillary+1);
		glVertex3f(ckx,0.04+ Landscape->gethigh(ckx + fieldposx, cky +1+ fieldposy) * Highscale+0.02, cky+1);
		glVertex3f(pillarx,0.04+(-pillarhight+ Landscape->gethigh(pillarx + fieldposx, pillary +1+ fieldposy)) * Highscale+0.02, pillary+1);
	glEnd();
	for (int i=Kxbegin;i<Kxend;i++) {
		for (int l=Kybegin;l<Kyend;l++) {
			if ((l+fieldposy>=0)&&(l+fieldposy<Landscape->SizeY)&&(i+fieldposx>=0)&&(i+fieldposx<Landscape->SizeX)&&(i+l>-(VSize+2)*xS)&&(i+l<(VSize+1)*xS)&&(i-l>-(VSize)*yS)&&(i-l<VSize*yS)) {
			glBegin(GL_LINES);	
				glColor3f(1.0f,1.0f,0.0f);
				glVertex3f(i+0.5,-0.02+(-pillarhight+ Landscape->gethigh(pillarx + fieldposx, pillary + fieldposy)) * Highscale , l+0.5);
				glVertex3f(i+1+0.5,-0.02+ (-pillarhight+ Landscape->gethigh(pillarx + fieldposx, pillary + fieldposy)) * Highscale, l+0.5);
			glEnd();
			glBegin(GL_LINES);	
				glColor3f(1.0f,1.0f,0.0f);
				glVertex3f(i+0.5,-0.02+(-pillarhight+ Landscape->gethigh(pillarx + fieldposx, pillary + fieldposy)) * Highscale, l+0.5);
				glVertex3f(i+0.5,-0.02+(-pillarhight+ Landscape->gethigh(pillarx + fieldposx, pillary + fieldposy)) * Highscale, l+1+0.5);
			glEnd();
			}
		}
	}
}
   // Spawnvorschau zeichnen
if (spawnbuild) {
	glDisable(GL_LIGHTING);	
	glLoadIdentity();				// Reset The View
	glTranslatef(0.0f,-0.5f,-10.0f);
	glRotatef(30,1.0f,0.0f,0.0f);	
	glRotatef(45,0.0f,1.0f,0.0f);
	glColor3f(1.0,0.0,0.0);
	DrawmapRectangle(ckx,cky,0.04);
	if (drawspawn) {
		for (int i=spawnystart;i<=spawnyend;i++) {
			DrawmapRectangle(spawnxstart,i,0.04);
			DrawRectangle(spawnxstart,i,Landscape->gethigh(spawnxstart+fieldposx,spawnystart+fieldposy),0.04);
		}
		for (int i=spawnxstart;i<=spawnxend;i++) {
			DrawmapRectangle(i,spawnystart,0.04);
			DrawRectangle(i,spawnystart,Landscape->gethigh(spawnxstart+fieldposx,spawnystart+fieldposy),0.04);
		}
	}
	}
if (bahnsteigbuild) {
	glDisable(GL_LIGHTING);	
	glLoadIdentity();				// Reset The View
	glTranslatef(0.0f,-0.5f,-10.0f);
	glRotatef(30,1.0f,0.0f,0.0f);	
	glRotatef(45,0.0f,1.0f,0.0f);
	glColor3f(1.0,0.0,0.0);
	DrawmapRectangle(ckx,cky,0.04);
	if (drawbahnsteig) {
		for (int i=bsteigystart;i<=bsteigyend;i++) {
			DrawmapRectangle(bsteigxstart,i,0.04);
		}
		for (int i=bsteigxstart;i<=bsteigxend;i++) {
			DrawmapRectangle(i,bsteigystart,0.04);
		}
	}
	}
	glutSwapBuffers();	
}



void keyPressed(unsigned char key, int x, int y)  {
    usleep(100);
    if (key == ESCAPE) 
    { 
    	glutDestroyWindow(glutwindow); 
    }
	if (key == '1') 
    { 
      VSize=5;
	  ReSizeViewPort();	
    }
	if (key == '5') 
    { 
      rotateview+=90;
	  ReSizeViewPort();	
	  if (rotateview==360) rotateview=0;	
    }
	if (key == '6') 
    { 
      rotateview-=90;
	  ReSizeViewPort();	
	  if (rotateview<0) rotateview=270;	
    }
	if (key == '2') 
    { 
      VSize=10;
	  ReSizeViewPort();
    }
	if (key == '3') 
    { 
      VSize=20;
	  ReSizeViewPort();
    }
	if (key == '4') 
    { 
      VSize=40;
	  ReSizeViewPort();
    }
	if (key == 'q') showfahrplaene=!showfahrplaene;
	if (key == 'x') stopgame=!stopgame;
	if (key == 'g') Grid=!Grid;
	if (key == 'b') editterrain=!editterrain;
	if (key == 'p') Polys=!Polys;
	if (key == 'w') Landscape->switchwatermask();
	if (key == 't') laytrack=!laytrack;
	if (key == 'i')	pillarbuild=!pillarbuild;	
	if (key == 's') spawnbuild=!spawnbuild;
	if (key == 'd') signalbuild=!signalbuild;
	if (key == 'm') RN->BuildSuperNodeList(Landscape->SizeX,Landscape->SizeY);
	if (key == 'f') depotbuild=!depotbuild;
	if (key == 'h') buildtrainstation=!buildtrainstation;
	if (key == 'z') zugselect=!zugselect;
	if (key == 'u') fahrplan=!fahrplan;
	if (key == 'o') showsupernodenetwork=!showsupernodenetwork;
    if (key == 'e') deletetrack=!deletetrack;
	if (key == 'j') bahnsteigbuild=!bahnsteigbuild;
	if (key == 'y') RN->BuildSignalNetwork();
	if (key == 'v') {zugsicht=!zugsicht;ReSizeGLScene(SHeight,SWidth);}
	if (key == 'l') selectdepot=!selectdepot;

}


void special(int key, int x, int y) {
  switch (key) {
  case GLUT_KEY_LEFT:
		fieldposx--;
  		fieldposy--;
    break;
  case GLUT_KEY_RIGHT:
	    fieldposx++;
  		fieldposy++;
    break;
  case GLUT_KEY_DOWN:
	  fieldposx--;
  	  fieldposy++;
    break;
  case GLUT_KEY_UP:
	  fieldposx++;
  	  fieldposy--;
   break;
  case GLUT_KEY_F5:
	  prv->SaveAll("testsaveall.sav");
  break;
  case GLUT_KEY_F6:
	  prv->LoadAll("testsaveall.sav");
  break;
  }
}

void mouse2map(int x, int y, int *rx,int *ry) {
	GLint viewport[4];
  	GLdouble mvmatrix[16], projmatrix[16];
  	GLint realy;
  	GLdouble wx, wy, wz;
	double mindist=1000000;
	double adist;
	int tx,ty;
	glGetIntegerv (GL_VIEWPORT, viewport);
    glGetDoublev (GL_MODELVIEW_MATRIX, mvmatrix);
    glGetDoublev (GL_PROJECTION_MATRIX, projmatrix);
    tx=0;
	ty=0;
	realy = viewport[3] - (GLint) y - 1;
	y=realy;
    //printf ("Coordinates at cursor are (%4d, %4d %4d)\n",x,y, realy);
	int Kybegin= -45;
	int Kyend= 45;
	int Kxbegin = -45;
	int Kxend = 45;
  	float Highscale=0.08;
	for (int i=Kxbegin;i<Kxend;i++) {
		for (int l=Kybegin;l<Kyend;l++) {
			if ((l+fieldposy>=0)&&(l+fieldposy<Landscape->SizeY)&&(i+fieldposx>=0)&&(i+fieldposx<Landscape->SizeX)&&(i+l>-(VSize+2)*xS)&&(i+l<(VSize+1)*xS)&&(i-l>-(VSize)*yS)&&(i-l<VSize*yS)) {
    			gluProject(i,Landscape->gethigh(i + fieldposx, l + fieldposy) * Highscale,l,mvmatrix, projmatrix, viewport, &wx, &wy, &wz);
				adist=(wx-x)*(wx-x)+(wy-y)*(wy-y);			
				if (adist<mindist) {
					mindist=adist;
					tx=i;ty=l;		
				}
			}
		}
	}
	printf("return: %i,%i,%i %f bebaut: %i\n",Landscape->Bgethigh(tx+fieldposx,ty+fieldposy),tx,ty,mindist,Landscape->bebaut[tx+fieldposx][ty+fieldposy]);
	*rx=tx;
	*ry=ty;
}

void mouse2mapkachel(int x, int y, int *rx,int *ry) {
	GLint viewport[4];
  	GLdouble mvmatrix[16], projmatrix[16];
  	GLint realy;
  	GLdouble wx, wy, wz;
	double mindist=1000000;
	double adist;
	int tx,ty;
	
	glGetIntegerv (GL_VIEWPORT, viewport);
    glGetDoublev (GL_MODELVIEW_MATRIX, mvmatrix);
    glGetDoublev (GL_PROJECTION_MATRIX, projmatrix);
    tx=0;
	ty=0;
	realy = viewport[3] - (GLint) y - 1;
	y=realy;
    //printf ("Coordinates at cursor are (%4d, %4d %4d)\n",x,y, realy);
	int Kybegin= -45;
	int Kyend= 45;
	int Kxbegin = -45;
	int Kxend = 45;
	float xS=1.4;
	float yS=2.5/AspectRatio;
  	float Highscale=0.08;
	for (int i=Kxbegin;i<Kxend;i++) {
		for (int l=Kybegin;l<Kyend;l++) {
			if ((l+fieldposy>=0)&&(l+fieldposy<Landscape->SizeY)&&(i+fieldposx>=0)&&(i+fieldposx<Landscape->SizeX)&&(i+l>-(VSize+2)*xS)&&(i+l<(VSize+1)*xS)&&(i-l>-(VSize)*yS)&&(i-l<VSize*yS)) {
    			gluProject(i+0.5,Landscape->getmphigh(i + fieldposx, l + fieldposy) * Highscale,l+0.5,mvmatrix, projmatrix, viewport, &wx, &wy, &wz);
				adist=(wx-x)*(wx-x)+(wy-y)*(wy-y);			
				if (adist<mindist) {
					mindist=adist;
					tx=i;ty=l;		
				}
			}
		}
	}
	//printf("return kachelpos: %i,%i,%i %f\n",Landscape->high[tx+fieldposx][ty+fieldposy],tx,ty,mindist);
	*rx=tx;
	*ry=ty;
}




void mouse2zug(int x, int y) {
	GLint viewport[4];
  	GLdouble mvmatrix[16], projmatrix[16];
  	GLint realy;
  	GLdouble wx, wy, wz;
	double mindist=1000000;
	double adist;
	glGetIntegerv (GL_VIEWPORT, viewport);
    glGetDoublev (GL_MODELVIEW_MATRIX, mvmatrix);
    glGetDoublev (GL_PROJECTION_MATRIX, projmatrix);
	realy = viewport[3] - (GLint) y - 1;
	y=realy;
    //printf ("Coordinates at cursor are (%4d, %4d %4d)\n",x,y, realy);
  	float Highscale=0.08;
  
	ZUGNODE *zNode;
	ZUGNODE *mNode=0;
	zNode=prv->firstzug;
	while (zNode!=0) {
		gluProject(0.5+zNode->zug.x-fieldposx,Landscape->getmphigh(zNode->zug.x,zNode->zug.y) * Highscale,0.5+zNode->zug.y-fieldposy,mvmatrix, projmatrix, viewport, &wx, &wy, &wz);
				adist=(wx-x)*(wx-x)+(wy-y)*(wy-y);			
		//		printf("...> %f %f %p %f\n",wx,wy,zNode,adist);
				if (adist<mindist) {
					mindist=adist;
					mNode=zNode;
				}					
		zNode=zNode->pNext;
	}
	if (mindist<10000) {
		selectetzug=mNode;
		printf("Zug gewhlt %p %f\n",mNode,mindist);
		//neues Fenster mit Zugeigenschaften::---------------------
		createzugwindow();
	}
}


void mouse (int button, int state, int x, int y) {
	if (((button == GLUT_LEFT_BUTTON)&&(state == GLUT_DOWN))&&selectdepot) {
		int px,py;
		mouse2mapkachel(x,y,&px,&py);
		usleep(20000);		
		DepotNodeClass *dpNode=RN->depotlistfirst;
		while (dpNode!=0) {
			if ((dpNode->xpos==px+fieldposx)&&(dpNode->ypos==py+fieldposy)) dpNode->select();
			dpNode=dpNode->pNext;
		}
	}
	if (((button == GLUT_LEFT_BUTTON)&&(state == GLUT_DOWN))&&editterrain) {
		int px,py;
		mouse2map(x,y,&px,&py);
		usleep(20000);
		if (Landscape->checksethigh(px+fieldposx,py+fieldposy,Landscape->gethigh(px+fieldposx,py+fieldposy)+4))		
			Landscape->sethigh(px+fieldposx,py+fieldposy,Landscape->gethigh(px+fieldposx,py+fieldposy)+4);
	}
	if (((button == GLUT_RIGHT_BUTTON)&&(state == GLUT_DOWN))&&editterrain) {
		int px,py;
		mouse2map(x,y,&px,&py);
		usleep(20000);		
		if (Landscape->checksethigh(px+fieldposx,py+fieldposy,Landscape->gethigh(px+fieldposx,py+fieldposy)-4))
			Landscape->sethigh(px+fieldposx,py+fieldposy,Landscape->gethigh(px+fieldposx,py+fieldposy)-4);
	}
	if (((button == GLUT_LEFT_BUTTON)&&(state == GLUT_DOWN))&&laytrack) {
		int px,py;
		mouse2mapkachel(x,y,&px,&py);
		usleep(20000);		
		RN->AppendTrack(px+fieldposx,py+fieldposy,fitTrack(px+fieldposx,py+fieldposy,tracktype),Landscape->getmphigh(px+fieldposx,py+fieldposy),0,0,0,0,0,0);
		char text[30];sprintf(text,"%i$",200);
		TB->AppendText(text,px+fieldposx,py+fieldposy,Landscape->Bgethigh(px+fieldposx,py+fieldposy),1.0,0.0,0.0);	
		//RN->AppendTrack(px+fieldposx,py+fieldposy,fitTrack(px+fieldposx,py+fieldposy,tracktype),Landscape->getmphigh(px+fieldposx,py+fieldposy),0,0,0,0);
	}
	if (((button == GLUT_LEFT_BUTTON)&&(state == GLUT_DOWN))&&deletetrack) {
		int px,py;
		mouse2mapkachel(x,y,&px,&py);
		usleep(20000);		
		RN->deletetrack(px+fieldposx,py+fieldposy);	
	}
	if (((button == GLUT_RIGHT_BUTTON)&&(state == GLUT_DOWN))&&laytrack) {
		tracktype++;
		if (tracktype>6) tracktype=1;
	}
	if (((button == GLUT_LEFT_BUTTON)&&(state == GLUT_DOWN))&&pillarbuild) {
		int px,py;
		mouse2mapkachel(x,y,&px,&py);
		usleep(20000);		
		pillarx=px;
		pillary=py;
		oldmousex=x;
		oldmousey=y;
	}
	if (((button == GLUT_LEFT_BUTTON)&&(state == GLUT_DOWN))&&fahrplan&&selectetzug) {
		int px,py;
		int linetoadd=0;
		mouse2mapkachel(x,y,&px,&py);
		if (zugwindowactiv) linetoadd=fahrplanbrowser->value();
		prv->AddFahrplanEintrag(&selectetzug->zug,px+fieldposx,py+fieldposy,linetoadd);				
		//selectetzug->zug.AddFahrplanEintrag(px+fieldposx,py+fieldposy);
		if (zugwindowactiv) update_fahrplan_window();
	}
	if (((button == GLUT_LEFT_BUTTON)&&(state == GLUT_UP))&&pillarbuild) {
		pillargrid=0;
		//prv->AppendObject(pillarx+fieldposx,pillary+fieldposy,10+(int)(-pillarhight/4),Landscape->high[pillarx+fieldposx][pillary+fieldposy]);
	}
	if (((button == GLUT_LEFT_BUTTON)&&(state == GLUT_DOWN))&&depotbuild) {
		int px,py;
		mouse2mapkachel(x,y,&px,&py);
		usleep(20000);		
		bsteigxstart=px;
		bsteigystart=py;
	}
	if (((button == GLUT_LEFT_BUTTON)&&(state == GLUT_UP))&&depotbuild) {
		drawbahnsteig=0;
		if (bsteigystart!=bsteigyend) {
			for (int i=bsteigystart;i<=bsteigyend;i++) {
			RN->AppendTrack(bsteigxstart+fieldposx,i+fieldposy,6,Landscape->gethigh(bsteigxstart+fieldposx,bsteigystart+fieldposy),0,0,0,0,0,0);			
			}		
		}
		if (bsteigxstart!=bsteigxend) {
			for (int i=bsteigxstart;i<=bsteigxend;i++) {
		RN->AppendTrack(i+fieldposx,bsteigystart+fieldposy,5,Landscape->gethigh(bsteigxstart+fieldposx,bsteigystart+fieldposy),0,0,0,0,0,0);
			}
		}
		RN->AppendDepot(bsteigxstart+fieldposx,bsteigystart+fieldposy,Landscape->gethigh(bsteigxstart+fieldposx,bsteigystart+fieldposy));
		RN->AppendSuperNode(bsteigxstart+fieldposx,bsteigystart+fieldposy,RN->RailTrackfirst[bsteigxstart+fieldposx][bsteigystart+fieldposy]);
		RN->AppendSuperNode(bsteigxend+fieldposx,bsteigyend+fieldposy,RN->RailTrackfirst[bsteigxend+fieldposx][bsteigyend+fieldposy]);
	}
	if (((button == GLUT_LEFT_BUTTON)&&(state == GLUT_UP))&&buildtrainstation) {
		int px,py;
		mouse2mapkachel(x,y,&px,&py);
		//prv->AppendObject(px+fieldposx,py+fieldposy,21,Landscape->high[px+fieldposx][py+fieldposy]);
		activeTS=RN->AppendTrainStation(px+fieldposx,py+fieldposy,Landscape->Bgethigh(px+fieldposx,py+fieldposy));
	}
	if (((button == GLUT_LEFT_BUTTON)&&(state == GLUT_DOWN))&&spawnbuild) {
		int px,py;
		mouse2mapkachel(x,y,&px,&py);
		usleep(20000);		
		spawnxstart=px;
		spawnystart=py;
	}
	if (((button == GLUT_LEFT_BUTTON)&&(state == GLUT_DOWN))&&bahnsteigbuild) {
		int px,py;
		mouse2mapkachel(x,y,&px,&py);
		usleep(20000);		
		bsteigxstart=px;
		bsteigystart=py;
	}
	if (((button == GLUT_LEFT_BUTTON)&&(state == GLUT_DOWN))&&zugselect) {
		mouse2zug(x,y);
		usleep(20000);				
	}
	if (((button == GLUT_LEFT_BUTTON)&&(state == GLUT_UP))&&spawnbuild) {
		drawspawn=0;
		if (spawnystart!=spawnyend) for (int i=spawnystart;i<=spawnyend;i++) {
			RN->AppendTrack(spawnxstart+fieldposx,i+fieldposy,6,Landscape->gethigh(spawnxstart+fieldposx,spawnystart+fieldposy),0,0,0,0,0,0);
		}
		if (spawnxstart!=spawnxend) for (int i=spawnxstart;i<=spawnxend;i++) {
			RN->AppendTrack(i+fieldposx,spawnystart+fieldposy,5,Landscape->gethigh(spawnxstart+fieldposx,spawnystart+fieldposy),0,0,0,0,0,0);
		}
		
	}
	if (((button == GLUT_LEFT_BUTTON)&&(state == GLUT_UP))&&bahnsteigbuild) {
		drawbahnsteig=0;
		//Landscape->buildbahnsteig();
		if (bsteigystart!=bsteigyend) {
			for (int i=bsteigystart;i<=bsteigyend;i++) {
			RN->AppendTrack(bsteigxstart+fieldposx,i+fieldposy,6,Landscape->gethigh(bsteigxstart+fieldposx,bsteigystart+fieldposy),0,0,0,1,0,0);			
			}
		RN->AppendPlattform(activeTS,bsteigxstart+fieldposx,bsteigystart+fieldposy,bsteigxstart+fieldposx,bsteigyend+fieldposy,1);
		}
		if (bsteigxstart!=bsteigxend) {
			for (int i=bsteigxstart;i<=bsteigxend;i++) {
		RN->AppendTrack(i+fieldposx,bsteigystart+fieldposy,5,Landscape->gethigh(bsteigxstart+fieldposx,bsteigystart+fieldposy),0,0,0,1,0,0);
			}
		RN->AppendPlattform(activeTS,bsteigxstart+fieldposx,bsteigystart+fieldposy,bsteigxend+fieldposx,bsteigystart+fieldposy,1);
		}
	}
	if (((button == GLUT_LEFT_BUTTON)&&(state == GLUT_DOWN))&&signalbuild) {
		int px,py;
		mouse2mapkachel(x,y,&px,&py);
		if ((px!=sigx)||(py!=sigy)) rnode=0;
		sigx=px;sigy=py;
		if (rnode==0) rnode=RN->RailTrackfirst[px+fieldposx][py+fieldposy];
		if (rnode==0) goto ok;
		if (rnode->signal1&&rnode->signal2) {rnode->signal2=0;rnode->signal1=0;goto ok;}
		if (rnode->signal1&&!rnode->signal2) {rnode->signal2=1;rnode->signal1=0;goto ok;}
		if (!rnode->signal1&&rnode->signal2) {rnode->signal1=1;rnode->signal2=1;goto ok;}
		if (!rnode->signal1&&!rnode->signal2) {rnode->signal1=1;goto ok;}
		ok:
		RN->BuildSuperNodeListFromPoint(px,py,0,rnode->hight,0);
		SUPERNODE *sNode=RN->supernodelistfirst;
		while (sNode!=0) {
			if ((sNode->x==px+fieldposx)&&(sNode->y==py+fieldposy)) {
				RN->BuildSuperNodeDirTree(sNode,rnode->hight);
				RN->MakeSuperNodeNetFromNode(sNode);
			}
			sNode=sNode->pNext;
		}		
		usleep(20000);
	}
	if (((button == GLUT_RIGHT_BUTTON)&&(state == GLUT_DOWN))&&signalbuild) {
		if (rnode==0) rnode=RN->RailTrackfirst[sigx+fieldposx][sigy+fieldposy]; else rnode=rnode->pNext;
		if (rnode==0) rnode=RN->RailTrackfirst[sigx+fieldposx][sigy+fieldposy];
	}
}
void passivemotion (int x, int y) {
	if (editterrain) {
		mouse2map(x,y,&cfx,&cfy);
	}
	if (laytrack||pillarbuild||spawnbuild||!drawspawn) {
		mouse2mapkachel(x,y,&ckx,&cky);
	}
	if (y>SHeight-10) scrolldown=1;else scrolldown=0;
	if (y<10) scrollup=1;else scrollup=0;
	if (x<10) scrollleft=1;else scrollleft=0;
	if (x>SWidth-10) scrollright=1; else scrollright=0;
}
void motion (int x, int y) {
	if (pillarbuild) {
		pillarhight=(int)((y-oldmousey)/16)*4;
		if (pillarhight>0) pillarhight=0;
		pillargrid=1;
	}
	if (spawnbuild) {
		int px,py;
		mouse2mapkachel(x,y,&px,&py);
		usleep(20000);		
		spawnxend=px;
		spawnyend=py;
		drawspawn=1;
	}
	if (bahnsteigbuild) {
		int px,py;
		mouse2mapkachel(x,y,&px,&py);
		usleep(20000);		
		bsteigxend=px;
		bsteigyend=py;
		drawbahnsteig=1;
	}
	if (depotbuild) {
		int px,py;
		mouse2mapkachel(x,y,&px,&py);
		usleep(20000);		
		bsteigxend=px;
		bsteigyend=py;
		drawbahnsteig=1;
	}
}



void LoadGoodTypes() {
	DIR           *dir_p;
    struct dirent *dir_entry_p;
    dir_p = opendir("goods/");
    int i=0;
    while( NULL != (dir_entry_p = readdir(dir_p)))
    {
        if (i>1) {
        printf("found good:: %s\n",dir_entry_p->d_name);			
		GNODE *newGood;
		newGood = new GNODE;
			
	if (chdir("goods")) printf("error cant chdir to goods\n");
	char b[200];
	getcwd(b,200);	
	char *fn =dir_entry_p->d_name;
	FILE *fd;
	if (NULL == (fd = fopen (fn, "r")))
		{
		printf("error!\n");
		printf("Can't open this good '%s', ejecting!\n", fn);
		} //else printf("file %s loadet\n",fn);
	for (int i=0;i<100;i++) {	
		char s1[100];
		char s2[100];
		fscanf (fd, "%s\n%s\n",&s1,&s2);		
		if (cmp(s1,"name")) strcpy(newGood->name,s2);
		if (cmp(s1,"pays")) newGood->pays=atoi(s2);		
		if (cmp(s1,"endef")) goto fertig;
	}	
	fertig:	
	if (chdir("../")) printf("error\n");
	getcwd(b,200);
	
		AppendGoodTypeClass(newGood);			
        }
        i++;
    }
	closedir(dir_p);
}

void LoadObjects() {
	DIR           *dir_p;
    struct dirent *dir_entry_p;
    dir_p = opendir("objects/");
    int i=0;
    while( NULL != (dir_entry_p = readdir(dir_p)))
    {
        if (i>1) {
        //printf("found:: %s\n",dir_entry_p->d_name);			
		ObjectClass *newObject;
		newObject = new ObjectClass();
		
		newObject->load(dir_entry_p->d_name);
		AppendObjectClass(newObject);			
        }
        i++;
    }
    closedir(dir_p);
	
	//die festverkabelten modelle suchen und nummern zuweisen;
	ObjectClass *objcl=objectclasslistfirst;
	while(objcl) {		
		if (cmp(objcl->objectname,"track1plane")) hcm[0]=objcl;
		if (cmp(objcl->objectname,"track2plane")) hcm[1]=objcl;
		if (cmp(objcl->objectname,"track3plane")) hcm[2]=objcl;
		if (cmp(objcl->objectname,"track4plane")) hcm[3]=objcl;
		if (cmp(objcl->objectname,"track5plane")) hcm[4]=objcl;
		if (cmp(objcl->objectname,"track6plane")) hcm[5]=objcl;
		if (cmp(objcl->objectname,"track5down")) hcm[6]=objcl;
		if (cmp(objcl->objectname,"track5rising")) hcm[7]=objcl;
		if (cmp(objcl->objectname,"track6down")) hcm[8]=objcl;
		if (cmp(objcl->objectname,"track6rising")) hcm[9]=objcl;	
		if (cmp(objcl->objectname,"signalleftgreen")) hcm[10]=objcl;	
		if (cmp(objcl->objectname,"signalleftred")) hcm[11]=objcl;	
		if (cmp(objcl->objectname,"signalrightgreen")) hcm[12]=objcl;	
		if (cmp(objcl->objectname,"signalrightred")) hcm[13]=objcl;		
		if (cmp(objcl->objectname,"bahnsteig1")) hcm[14]=objcl;				
		if (cmp(objcl->objectname,"bahnsteig2")) hcm[15]=objcl;				
		if (cmp(objcl->objectname,"bahnhof")) hcm[16]=objcl;				
		if (cmp(objcl->objectname,"redball")) hcm[17]=objcl;				
		if (cmp(objcl->objectname,"testlok")) hcm[18]=objcl;				
		if (cmp(objcl->objectname,"testwagon")) hcm[19]=objcl;				
		if (cmp(objcl->objectname,"longwagon")) hcm[20]=objcl;				
		if (cmp(objcl->objectname,"oilwagon")) hcm[21]=objcl;				
		if (cmp(objcl->objectname,"z")) hcm[22]=objcl;				
		if (cmp(objcl->objectname,"u")) hcm[23]=objcl;
		if (cmp(objcl->objectname,"g")) hcm[24]=objcl;
		if (cmp(objcl->objectname,"s")) hcm[25]=objcl;
		if (cmp(objcl->objectname,"p")) hcm[26]=objcl;
		if (cmp(objcl->objectname,"i")) hcm[27]=objcl;
		if (cmp(objcl->objectname,"e")) hcm[28]=objcl;
		if (cmp(objcl->objectname,"l")) hcm[29]=objcl;	
		if (cmp(objcl->objectname,"lumberwagon")) hcm[30]=objcl;	
		if (cmp(objcl->objectname,"coalwagon")) hcm[31]=objcl;	
		if (cmp(objcl->objectname,"grainwagon")) hcm[32]=objcl;	
		if (cmp(objcl->objectname,"steelwagon")) hcm[33]=objcl;	
		if (cmp(objcl->objectname,"ironorewagon")) hcm[34]=objcl;	
		if (cmp(objcl->objectname,"livestockwagon")) hcm[35]=objcl;	
		if (cmp(objcl->objectname,"maindepot")) hcm[36]=objcl;				
		objcl=objcl->pNext;
	}
}

int pnrx(int a) {
	if (a != 0)
	{ return rand() % a;}
	else return 0;
}



void *BaumThread(void *arg) {
	int cv=1;
	int x,y;
	while (cv!=0) {
		for (int i=0;i<100;i++) {
			x=pnrx(256);
			y=pnrx(256);
			//if (Landscape->objpointer[x][y]<5) Landscape->objpointer[x][y]++;
		}
		usleep(1000);
		
	}
	return(0);
}



void *ZugThread(void *arg) {
	int cv=1;
	ZUGNODE *zNode=prv->lastzug;
	zNode->zug.hight=Landscape->Bgethigh(zNode->zug.x,zNode->zug.y);
	while (!zNode->zug.fahrplanpointer) {
		usleep(100000);
	}
	                                                
	zNode->zug.sNodeStart=RN->FindNextSupernode(zNode->zug.x,zNode->zug.y,zNode->zug.track,zNode->zug.dir);
	zNode->zug.gotoSuperNode=1;
	
	while (cv!=0) {
		while (stopgame) {usleep(100000);}
		while (AmSpeichern) {usleep(100000);}		
		if (zNode->zug.aktion==1) { //zug hat kein ziel aber einen eintrag im fahrplan			
			zNode->zug.zielnode=RN->TraceTrack(zNode->zug.x,zNode->zug.y,
								Landscape->Bgethigh(zNode->zug.x,zNode->zug.y),(zNode->zug.kachelin),0);
			zNode->zug.habeZiel=1;
			zNode->zug.aktion=2; //zug ist ohne MTABauf dem weg zu einem punkt an dem es eine MTAB gibt
			zNode->zug.notifyneuerfahrplaneintrag();
		}
		if (zNode->zug.aktion==3) {		
			if ((zNode->zug.x==zNode->zug.zielnode->x)&&(zNode->zug.y==zNode->zug.zielnode->y)) {
				zNode->zug.aktion=4;//zug ist am zielnode angekommen und braucht nun eine mtb bis zum fpnode.
				zNode->zug.notifyneuerfahrplaneintrag();
			}
		}
		if (zNode->zug.aktion==5) {		
			//zug ist am zielnode und will jetzt neue MTB zum fpNode
			
			if(prv->CalculateMarschtabelle((zNode->zug.kachelin+2)%4,zNode->zug.BEnode,&zNode->zug,0)) {
				zNode->zug.zielnode=zNode->zug.marschtabellennodefirst->SuperNode;
				workingonmarschtabelle=0;
				zNode->zug.marschtabellenpointer=zNode->zug.marschtabellennodelast;			
			zNode->zug.aktion=6;
			zNode->zug.notifyneuerfahrplaneintrag();			
			}
		}
		if (zNode->zug.aktion==7) {		
		}
		
		if (zNode->zug.fahrplanpointer) {			
			if (((zNode->zug.fahrplanpointer->target==0)&&(zNode->zug.x==zNode->zug.fahrplanpointer->SuperNode->x)&&(zNode->zug.y==zNode->zug.fahrplanpointer->SuperNode->y))||
				((zNode->zug.fahrplanpointer->target==1)&&(zNode->zug.x==zNode->zug.zielnode->x)&&(zNode->zug.y==zNode->zug.zielnode->y))){
				//aufladen
				if (zNode->zug.fahrplanpointer->target==1) {
					for (int i=0;i<40;i++) {
						if (zNode->zug.wag[i]!=0) {
							LagerNode *lNode=zNode->zug.fahrplanpointer->tsNode->LagerNodeFirst;
							while (lNode!=0) {
								if (zNode->zug.wag[i]->loads==lNode->good) {
									int maxload=zNode->zug.wag[i]->capacity-zNode->zug.loadamount[i];
									if (lNode->amount>maxload) {
										zNode->zug.loadamount[i]+=maxload;
										lNode->amount-=maxload;										
										char text[30];sprintf(text,"loadet: %i %s",maxload,lNode->good->name);
										TB->AppendText(text,zNode->zug.x,zNode->zug.y,i*2+Landscape->Bgethigh(zNode->zug.x,zNode->zug.y),1.1,1.0,1.0);	
									} else {
										zNode->zug.loadamount[i]+=lNode->amount;
										if (lNode->amount>0) {										
											char text[30];sprintf(text,"loadet: %i %s",lNode->amount,lNode->good->name);
											lNode->amount=0;									
											TB->AppendText(text,zNode->zug.x,zNode->zug.y,i*2+Landscape->Bgethigh(zNode->zug.x,zNode->zug.y),1.1,1.0,1.0);	
										}
									}									
								}
								lNode=lNode->pNext;
							}							
						}
					}
				
				}	
				//abladen
				if (zNode->zug.fahrplanpointer->target==1) {
					for (int i=0;i<40;i++) {
						if (zNode->zug.wag[i]!=0) {
							HONODE *hoNode=zNode->zug.fahrplanpointer->tsNode->connectetindustriesfirst;
							while (hoNode!=0) {
								PRODNODE *lNode=hoNode->oNode->Objecttype->requirelistfirst;
								while (lNode!=0) {
									if (zNode->zug.wag[i]->loads==lNode->good) {
											int m=zNode->zug.loadamount[i];
										    zNode->zug.loadamount[i]=0;
											char text[30];sprintf(text,"unloadet: %i %s",m,lNode->good->name);
											TB->AppendText(text,zNode->zug.x,zNode->zug.y,i*2+Landscape->Bgethigh(zNode->zug.x,zNode->zug.y),1.1,1.0,1.0);											
									}
									lNode=lNode->pNext;
								}
								hoNode=hoNode->pNext;
							}							
						}
					}
				
				}
				
				printf("an node angekommen, neue marschtabelle berechnen\n");
					if (zNode->zug.fahrplanpointer->target==1) usleep(2000000);		
					//---
					if (zNode->zug.marschtabellenpointer) zNode->zug.bNode=zNode->zug.marschtabellenpointer->SuperNode;
						else zNode->zug.bNode=zNode->zug.sNodeStart;
					zNode->zug.fahrplanpointer=zNode->zug.fahrplanpointer->pNext;
					if (zNode->zug.fahrplanpointer==NULL) zNode->zug.fahrplanpointer=zNode->zug.fahrplannodefirst;
					printf("bnode: %p, pointer: %p\n",zNode->zug.bNode,zNode->zug.fahrplanpointer);
					workingonmarschtabelle=1;
					printf("kachlpuit: %i\n",zNode->zug.kachelin);
					int cost=prv->CalculateMarschtabelle((zNode->zug.kachelin+2)%4,zNode->zug.bNode,&zNode->zug,0);
					if(cost) {
						zNode->zug.zielnode=zNode->zug.marschtabellennodefirst->SuperNode;
						workingonmarschtabelle=0;
						zNode->zug.marschtabellenpointer=zNode->zug.marschtabellennodelast;
						char text[30];sprintf(text,"new route, cost %i<-",cost);
						TB->AppendText(text,zNode->zug.x,zNode->zug.y,Landscape->Bgethigh(zNode->zug.x,zNode->zug.y),1.0,1.0,1.0);	
					} else {
						char text[30];sprintf(text,"no route to destination!");
						TB->AppendText(text,zNode->zug.x,zNode->zug.y,Landscape->Bgethigh(zNode->zug.x,zNode->zug.y),1.0,0.0,0.0);	
					}
					if ((zugwindowactiv)&&(zNode==selectetzug)) update_fahrplan_window();
			
				
			}			
		}	
		
		if (zNode->zug.marschtabellenpointer) {
			if ((zNode->zug.marschtabellenpointer!=zNode->zug.marschtabellennodefirst)&&(zNode->zug.marschtabellenpointer->SuperNode->x==zNode->zug.x)&&(zNode->zug.marschtabellenpointer->SuperNode->y==zNode->zug.y)) {								
				
	
				if ((zNode->zug.marschtabellenpointer->SuperNode->track->signal1)||(zNode->zug.marschtabellenpointer->SuperNode->track->signal2)) {				
					//warten vor rotem signal:
						zNode->zug.addsignaltowatchlist();					
						if (((zNode->zug.kachelin<2)&&(zNode->zug.marschtabellenpointer->SuperNode->track->signal1state))||		
										((zNode->zug.kachelin>=2)&&(zNode->zug.marschtabellenpointer->SuperNode->track->signal2state))) {
							 bool weiter=0;
								while (!weiter) {
									usleep(500000);
									weiter=1;
									if (((zNode->zug.kachelin<2)&&(zNode->zug.marschtabellenpointer->SuperNode->track->signal1state))||		
										((zNode->zug.kachelin>=2)&&(zNode->zug.marschtabellenpointer->SuperNode->track->signal2state))) weiter=0;									
								}
							}
						
//						zNode->zug.switchsignalsbehindtrain();
						zNode->zug.switchsignalsaheadoftrain();
						zNode->zug.switchsignalattrain();	
				}
				
			
				zNode->zug.neuesZiel=1;
				zNode->zug.NaechteSupernode=1;
				printf("mtbnode reached\n");	
				zNode->zug.dir=zNode->zug.marschtabellenpointer->dir;
				zNode->zug.marschtabellenpointer=zNode->zug.marschtabellenpointer->pPrev;
			} else {
				printf("normal\n");
			}
		}
		zNode->zug.kachelin=zNode->zug.dir;			
		if (zNode->zug.kachelin==0) zNode->zug.x++;
		if (zNode->zug.kachelin==1) zNode->zug.y++;
		if (zNode->zug.kachelin==2) zNode->zug.x--;
		if (zNode->zug.kachelin==3) zNode->zug.y--;			
		
		
		
		if ((zNode->zug.marschtabellenpointer!=zNode->zug.marschtabellennodefirst)&&(zNode->zug.marschtabellenpointer->SuperNode->x==zNode->zug.x)&&(zNode->zug.marschtabellenpointer->SuperNode->y==zNode->zug.y)) {									
				if (evaderedsignals) if (zNode->zug.signalaheadred()) {			
					int cost=prv->CalculateMarschtabelle((zNode->zug.kachelin+2)%4,zNode->zug.marschtabellenpointer->SuperNode,&zNode->zug,1);
					if(cost) {
						char text[40];sprintf(text,"Signal rot evading");
						TB->AppendText(text,zNode->zug.x,zNode->zug.y,Landscape->Bgethigh(zNode->zug.x,zNode->zug.y),1.0,1.0,1.0);						
						zNode->zug.zielnode=zNode->zug.marschtabellennodefirst->SuperNode;
						workingonmarschtabelle=0;
						zNode->zug.marschtabellenpointer=zNode->zug.marschtabellennodelast;
					} else {
						TB->AppendText("Signal vorraus rot, mh... lost",zNode->zug.x,zNode->zug.y,Landscape->Bgethigh(zNode->zug.x,zNode->zug.y),1.0,1.0,1.0);						
					}
				}
			}
		if ((zNode->zug.marschtabellenpointer!=zNode->zug.marschtabellennodefirst)&&(zNode->zug.marschtabellenpointer)&&((zNode->zug.marschtabellenpointer->SuperNode->x==zNode->zug.x)&&(zNode->zug.marschtabellenpointer->SuperNode->y==zNode->zug.y))) {
			printf("zNode->zug.dir: %izNode->zug.marschtabellenpointer->dir: %i\n",zNode->zug.dir,zNode->zug.marschtabellenpointer->dir);
			zNode->zug.dir=zNode->zug.marschtabellenpointer->dir;
		} else {
			bool deathend=1;		
			RNODE *mtrack;
			mtrack=RN->RailTrackfirst[zNode->zug.x][zNode->zug.y];
			while (mtrack!=0) { //obsolet alle tracks durchprobieren es gibt nur einen
			zNode->zug.hight=mtrack->hight;
			zNode->zug.ascent=0;
			zNode->zug.descent=0;			
			//hier NZX1
			
			//printf("matrackhight: %i, zughight: %i, rhight: %f moldhight: %i\n",mtrack->hight,zNode->zug.hight,zNode->zug.rh,zNode->zug.oldtrackhight);	
			//if (mtrack->hight==zNode->zug.oldtrackhight) {
				
			if (zNode->zug.dir==0) {
				/*if ((zNode->zug.rh==mtrack->hight)||
					(mtrack->tracktype==7)||(mtrack->tracktype==8)||
					((zNode->zug.oldtrackhight>6)&&(zNode->zug.oldtrackhight<11))) {*/
				if ((zNode->zug.rh==mtrack->hight)||
					((mtrack->tracktype==7)&&(zNode->zug.rh==mtrack->hight+2))
				  ||((mtrack->tracktype==8)&&(zNode->zug.rh==mtrack->hight-2))
					) {
				if (mtrack->tracktype==1) {zNode->zug.dir=3;deathend=0;}
				if (mtrack->tracktype==4) {zNode->zug.dir=1;deathend=0;}
				if (mtrack->tracktype==7) {zNode->zug.descent=1;deathend=0;}
				if (mtrack->tracktype==8) {zNode->zug.ascent=1;deathend=0;}
				deathend=0;
				}
			}
			if (zNode->zug.dir==1) {
				if ((zNode->zug.rh==mtrack->hight)||
					((mtrack->tracktype==9)&&(zNode->zug.rh==mtrack->hight-2))
				  ||((mtrack->tracktype==10)&&(zNode->zug.rh==mtrack->hight+2))
					) {
				if (mtrack->tracktype==1) {zNode->zug.dir=2;deathend=0;}
				if (mtrack->tracktype==2) {zNode->zug.dir=0;deathend=0;}
				if (mtrack->tracktype==9) {zNode->zug.ascent=1;deathend=0;}
				if (mtrack->tracktype==10) {zNode->zug.descent=1;deathend=0;}				
				deathend=0;
				}
			}
			if (zNode->zug.dir==2) {
				//printf("%i %f %i-------------------------\n",mtrack->tracktype,zNode->zug.rh,mtrack->hight);
				if ((zNode->zug.rh==mtrack->hight)||
					((mtrack->tracktype==7)&&(zNode->zug.rh==mtrack->hight-2))
				  ||((mtrack->tracktype==8)&&(zNode->zug.rh==mtrack->hight+2))
					) {
					//	printf("-------------------------\n");
				if (mtrack->tracktype==2) {zNode->zug.dir=3;deathend=0;}	
				if (mtrack->tracktype==3) {zNode->zug.dir=1;deathend=0;}
				if (mtrack->tracktype==8) {zNode->zug.descent=1;deathend=0;}		
				if (mtrack->tracktype==7) {zNode->zug.ascent=1;deathend=0;}
				deathend=0;
				}
			}
			if (zNode->zug.dir==3) {
				if ((zNode->zug.rh==mtrack->hight)||
					((mtrack->tracktype==9)&&(zNode->zug.rh==mtrack->hight+2))
				  ||((mtrack->tracktype==10)&&(zNode->zug.rh==mtrack->hight-2))
					) {
				if (mtrack->tracktype==3) {zNode->zug.dir=0;deathend=0;}
				if (mtrack->tracktype==4) {zNode->zug.dir=2;deathend=0;}
				if (mtrack->tracktype==10) {zNode->zug.ascent=1;deathend=0;}
				if (mtrack->tracktype==9) {zNode->zug.descent=1;deathend=0;}				
				deathend=0;
				}
			}
			//if ((zNode->zug.hight!=mtrack->hight)||((!zNode->zug.ascent)||(!zNode->zug.descent))) mtrack=0;
			if (mtrack!=0)  {
				zNode->zug.oldtracktype=mtrack->tracktype;zNode->zug.oldtrackhight=mtrack->hight;
			}
			
			mtrack=mtrack->pNext;
			}
			if (deathend==1) { // zug umdrehen weil deathend
				//zNode->zug.reversetrain();
				printf("deathend\n");
				/*
				zNode->zug.dir=(zNode->zug.dir+2)%4;
				zNode->zug.kachelin=(zNode->zug.kachelin+2)%4;				
				goto nochmal;
				*/
			}
			
		}		
		zNode->zug.kachelout=zNode->zug.dir;
		
		
			
		zNode->zug.move();
		zNode->zug.rh=(int)(zNode->zug.rh+0.1);	
	}
	return(0);
}


void CreateRandomIndustries(int num, char *name) {	
	ObjectClass *objcl=objectclasslistfirst;
	while(objcl) {
		if (cmp(objcl->objectname,name)) {
			for (int i=0;i<num;i++) {				
				int x=10+pnrx(Landscape->SizeX-objcl->sizex-20);
				int y=10+pnrx(Landscape->SizeY-objcl->sizex-20);
				int noway=0;
				//int x=10+pnrx(120);		
				//int y=10+pnrx(120);				
				if (Landscape->Bgethigh(x,y)>0) {
					for (int k=0;k<objcl->sizex+1;k++) 
						for (int m=0;m<objcl->sizey+1;m++) 					
							if ((Landscape->bebaut[x+k][y+m])||(!Landscape->checksethigh(x+k,y+m,Landscape->Bgethigh(x,y)))) goto fertig;					
					
					IndustrieListNODE *iNode=prv->IndustrieListFirst;
						while (iNode!=0) {
							if (((iNode->object->x-x)*(iNode->object->x-x)+(iNode->object->y-y)*(iNode->object->y-y))<100) {
								PRODNODE *pNode=iNode->object->Objecttype->producelistfirst;
								while (pNode!=0) {
									PRODNODE *p2Node=objcl->requirelistfirst;
									while (p2Node!=0) {
											if (pNode->good==p2Node->good) {noway=1;}
										p2Node=p2Node->pNext;
									}
									pNode=pNode->pNext;
								}
								PRODNODE *p3Node=iNode->object->Objecttype->requirelistfirst;
								while (p3Node!=0) {
									PRODNODE *p2Node=objcl->producelistfirst;
									while (p2Node!=0) {
											if (p3Node->good==p2Node->good) {noway=1;}
										p2Node=p2Node->pNext;
									}
									p3Node=p3Node->pNext;
								}
							}
						iNode=iNode->pNext;
					}
					if (!noway) {
					for (int k=0;k<objcl->sizex+1;k++) 
						for (int m=0;m<objcl->sizey+1;m++) 
							Landscape->sethigh(x+k,y+m,Landscape->Bgethigh(x,y));							
					for (int k=0;k<objcl->sizex;k++) 
						for (int m=0;m<objcl->sizey;m++)
							Landscape->bebaut[x+k][y+m]=1;							
					prv->AppendObject(x,y,objcl,Landscape->Bgethigh(x,y));												
					}
				}
				fertig:
				int u;u=1;				
			}
		}
		objcl=objcl->pNext;
	}
	
}

void CreateRandomMapObjects(char *fn) {			
	
	CreateRandomIndustries(3,"lumbermill");
	CreateRandomIndustries(5,"forest");	
	CreateRandomIndustries(5,"powerplant");
	CreateRandomIndustries(7,"coalmine");
	CreateRandomIndustries(7,"oilwells");
	CreateRandomIndustries(4,"oilraf");
	CreateRandomIndustries(6,"farm");	
	CreateRandomIndustries(4,"factory");	
	CreateRandomIndustries(7,"ironoremine");	
	CreateRandomIndustries(4,"steelmill");	
	CreateRandomIndustries(12000,"tree1");	
}





void createthread(int x) {
	if (pthread_create (&threads[x], NULL, ZugThread, &ids[x])) printf ("Threaderror\n");	
	usleep(300000);
}



void *MainTBthread(void *arg) {
	int cv=1;
	while (cv) {
		usleep(20000);
		TB->ticker();		
	}
	return(0);
}

void *MainTickerThread(void *arg) {
	int cv=1;
	while (cv) {
		usleep(5000000);
		IndustrieListNODE *iNode=prv->IndustrieListFirst;
		while (iNode!=0) {
			PRODNODE *pNode=iNode->object->Objecttype->producelistfirst;
			int i=0;
			while (pNode!=0) {
				//char text[30];sprintf(text,"prod: %s::%i",pNode->good->name,pNode->amount);
				//TB->AppendText(text,iNode->object->x,iNode->object->y,2*i+Landscape->Bgethigh(iNode->object->x,iNode->object->y),1.1,1.0,1.0);								
				i++;
				HTSNODE *htsNode=iNode->object->connectetstationsfirst;
				while (htsNode!=0) {
					htsNode->tsNode->AddGood(pNode->good,pNode->amount);
					htsNode=htsNode->pNext;
				}
				pNode=pNode->pNext;
			}
			iNode=iNode->pNext;	
		}
				
	
		TSNODE *tsNode=RN->firsttrainstation;
		while (tsNode!=0) {
				int i=0;
				LagerNode *lNode=tsNode->LagerNodeFirst;
				while (lNode!=0) {			
					char text[30];sprintf(text,"stock: %s::%i",lNode->good->name,lNode->amount);
					TB->AppendText(text,tsNode->x,tsNode->y,2*i+Landscape->Bgethigh(tsNode->x,tsNode->y),1.1,1.0,1.0);	
					lNode=lNode->pNext;
					i++;
				}
			tsNode=tsNode->pNext;
		}	
	}
	return(0);
}

void zoomin(Fl_Widget *o, void *p) {
	switch(VSize) {
		case 40 : {VSize=20;goto ok;}
	    case 20 : {VSize=10;goto ok;}
		case 10 : {VSize=5;goto ok;}
	}
	ok:
	ReSizeViewPort();	
}
void zoomout(Fl_Widget *o, void *p) {
	switch(VSize) {
		case 20 : {VSize=40;goto ok;}
	    case 10 : {VSize=20;goto ok;}
		case 5 : {VSize=10;goto ok;}
	}
	ok:
	ReSizeViewPort();	
}

void bulldoze(Fl_Widget *o, void *p) {
	disableswitches();
	deletetrack=1;
}
void buildtrack(Fl_Widget *o, void *p) {
	disableswitches();
    laytrack=1;
}

void haltgame(Fl_Widget *o,void *p) {
	stopgame=!stopgame;
}

void options(Fl_Widget *o,void *p) {
	createoptionswindow();
}


void createbuttonbar(int argc, char **argv) {
	buttonbar = new testwindow(FL_EMBOSSED_BOX,300,0,192,24,"TEST123");
 	{ Fl_Button* o = new Fl_Button(0, 0, 24, 24);
      o->image(image_zoomin);
	  o->callback(zoomin,window);
    }
	{ Fl_Button* o = new Fl_Button(24, 0, 24, 24);
      o->image(image_zoomout);
	  o->callback(zoomout,window);
    }
	{ Fl_Button* o = new Fl_Button(48, 0, 24, 24);
      o->image(image_lower);
    }    
    { Fl_Button* o = new Fl_Button(72, 0, 24, 24);
      o->image(image_raise);
    }
	{ Fl_Button* o = new Fl_Button(96, 0, 24, 24);
      o->image(image_railtrack);
	  o->callback(buildtrack,window);
    }
	{ Fl_Button* o = new Fl_Button(120, 0, 24, 24);
      o->image(image_disk);
	  o->callback(options,window);
    }
    { Fl_Button* o = new Fl_Button(144, 0, 24, 24);
      o->image(image_erase);
	  o->callback(bulldoze,window);
    }
    { Fl_Button* o = new Fl_Button(168, 0, 24, 24);
      o->image(image_exit);
	  o->callback(haltgame,window);
    }
    
  buttonbar->resizable(buttonbar);
  window->resizable(buttonbar);
  buttonbar->end();
  buttonbar->show(argc, argv);	
}

int main(int argc, char **argv) {  
	goodlistfirst=0;
	printf("zugspiel by Peterhans Hendel chochmah@gmx.net PreAlpha\n");	
	//if (pthread_create (&threads, NULL, BaumThread, &ids)) printf ("Threaderror\n");
  	LoadGoodTypes();	
	
	window = new testwindow(FL_UP_BOX,800,600,"outer");
//	window->set_modal();
  	new Fl_Toggle_Button(310,310,80,80,"&outer");
  	new Fl_Input(150,310,150,25,"input:");
  	popup = new Fl_Menu_Button(0,0,400,400);
  	popup->type(Fl_Menu_Button::POPUP3);
  	popup->add("This|is|a popup|menu");
  
	window->show(argc, argv);
	window->fullscreen();

  
  //window.show(argc,argv); // glut will die unless parent window visible
  	window->begin(); // this will cause Glut window to be a child
  

 	glutInitWindowSize(640, 480); 
 	glutInitWindowPosition(100,100); // place it inside parent window
  	glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGBA | GLUT_DEPTH | GLUT_MULTISAMPLE);
	glutwindow=glutCreateWindow("Zugspiel preAlpha");
  
  
	window->end();  
  window->begin();
createbuttonbar(argc,argv);
  window->show(argc,argv);
	window->end();
	
  	glutDisplayFunc(&DrawGLScene);  
  	
	glutFullScreen();
  	glutIdleFunc(&DrawGLScene);
  	glutReshapeFunc(&ReSizeGLScene);
  	glutKeyboardFunc(&keyPressed);
  	glutSpecialFunc (special);
  	glutMouseFunc(mouse);
  	glutPassiveMotionFunc(passivemotion);
  	glutMotionFunc(motion);
  
	currentObject = glGenLists(300);	 
  	LoadObjects();
	
	  //Landscape Initalisierung
	Landscape = new LandClass;
	prv = new LandscapeClass(Landscape);
	RN =  new RailNetworkClass;	
	prv->RN=RN;	
	printf("createt\n");
	
	TB = new TextBubbelClass;
	if (pthread_create (&TBthread, NULL, MainTBthread, &tbthreadid)) printf ("TB Threaderror\n");	
	if (pthread_create (&MTthread, NULL, MainTickerThread, &mtthreadid)) printf ("TB Threaderror\n");	
	//argv[1]="-c";
	if (argv[1] == "-c") {
		Landscape->CreateNewLandscape(256,256);
		Landscape->loadgradient("standartgradient.pov");
    	//Landscape->loadcolormap (argv[3]);
    	//Landscape->loadhighmap (argv[2]);
		Landscape->makediscrete();
		Landscape->makemidpoints();
	} else {
		prv->LoadAll("testsaveall.sav");
	}		
	Landscape->makemidpoints();
	Landscape->calccolors();
	Landscape->makefieldnormals();
		
  //CreateRandomMapObjects("randommap.ini");  
  	prv->CreateTSIndustrieConnetions();	
	
	TB = new TextBubbelClass;
	if (pthread_create (&TBthread, NULL, MainTBthread, &tbthreadid)) printf ("TB Threaderror\n");	
	if (pthread_create (&MTthread, NULL, MainTickerThread, &mtthreadid)) printf ("TB Threaderror\n");	
	
	window->show();
	
  	InitGL(480, 480);
  	window->end();  
	stopgame=0;
  	return Fl::run();
}



