
float color[6000][3];
float tri[3][3][4000];
GLfloat norm[6000][3];
int size;


void normalize(GLfloat v[3])
{
  GLfloat d = sqrt(v[0]*v[0] + v[1]*v[1] + v[2]*v[2]);
    v[0] /= d; v[1] /= d; v[2] /= d;
}

/* calculates a normalized crossproduct to v1, v2 */
void ncrossprod(float v1[3], float v2[3], float cp[3])
{
  cp[0] = v1[1]*v2[2] - v1[2]*v2[1];
  cp[1] = v1[2]*v2[0] - v1[0]*v2[2];
  cp[2] = v1[0]*v2[1] - v1[1]*v2[0];
  normalize(cp);
}

  /* calculates normal to the triangle designated by v1, v2, v3 */
void triagnormal(float v1[3], float v2[3], float v3[3], float norm[3])
{
  float vec1[3], vec2[3];

  vec1[0] = v3[0] - v1[0];  vec2[0] = v2[0] - v1[0];
  vec1[1] = v3[1] - v1[1];  vec2[1] = v2[1] - v1[1];
  vec1[2] = v3[2] - v1[2];  vec2[2] = v2[2] - v1[2];

  ncrossprod(vec2, vec1, norm);
}
//same with double
void triagnormald(double v1[3], double v2[3], double v3[3], float norm[3])
{
  float vec1[3], vec2[3];

  vec1[0] = v3[0] - v1[0];  vec2[0] = v2[0] - v1[0];
  vec1[1] = v3[1] - v1[1];  vec2[1] = v2[1] - v1[1];
  vec1[2] = v3[2] - v1[2];  vec2[2] = v2[2] - v1[2];

  ncrossprod(vec2, vec1, norm);
}


void Axes()
{
  int i,j;
  GLfloat axes_ambuse[] =   { 0.5, 0.0, 0.0, 1.0 };
    glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, axes_ambuse);
    glBegin(GL_LINES);
      glVertex3f(15, 0, 0); glVertex3f(-15, 0, 0);
      glVertex3f(0, 15, 0); glVertex3f(0, -15, 0);
      glVertex3f(0, 0, 15); glVertex3f(0, 0, -15);
    glEnd();
    for (i = 0; i < 3; i++) {
      glPushMatrix();
        glTranslatef(-10*(i==0), -10*(i==1), -10*(i==2));
        for (j = 0; j < 31; j++) {
//          glutSolidCube(0.3);
          glTranslatef(i==0, i==1, i==2);
        }
      glPopMatrix();
    }
  glPopAttrib();
  glEndList();
}


void loadfileobject(char *fn) {

	FILE *fd;
	int hex;
 	double v1[3], v2[3], v3[3];
        int ntris;
if (NULL == (fd = fopen (fn, "r")))
	{
	printf("error\n");
	printf("LoadModel: Can't open this, ejecting! %s\n", fn);
	}
	ntris = 0;
	/* Read them triangles */
	while (10 == fscanf (fd, "%lf %lf %lf %lf %lf %lf %lf %lf %lf %i",
		&v1[0], &v1[2], &v1[1], 
		&v2[0], &v2[2], &v2[1],
		&v3[0], &v3[2], &v3[1], &hex))
	{
  		   //fileobj[on].col[ntris] = hex;
		   triagnormald(v1,v2,v3,norm[ntris]);
		norm[ntris][1]=norm[ntris][1];
		norm[ntris][0]=-norm[ntris][0];
		norm[ntris][2]=-norm[ntris][2];
		
		   tri[0][0][ntris] = v1[0];
		   tri[0][1][ntris] = v1[2];
		   tri[0][2][ntris] = v1[1];

		   tri[1][0][ntris] = v2[0];
		   tri[1][1][ntris] = v2[2];
		   tri[1][2][ntris] = v2[1];

		   tri[2][0][ntris] = v3[0];
		   tri[2][1][ntris] = v3[2];
		   tri[2][2][ntris] = v3[1];

                color[ntris][0] = ((float) (hex / 65536)) / 256.0;
                color[ntris][1] = ((float) ((hex % 65536) / 256)) / 256.0;
                color[ntris][2] = ((float) (hex % 256)) / 256.0;

/*
printf("%f\n",sad);
printf("loading1 %d %f %f %f\n",ntris,v1[0],v1[1],v1[2]);
printf("loading2 %d %f %f %f\n",ntris,v2[0],v2[1],v2[2]);
printf("loading3 %d %f %f %f\n",ntris,v3[0],v3[1],v3[2]);
printf("Normal %d %f %f %f\n",ntris,fileobj[on].norm[ntris][0],fileobj[on].norm[ntris][1],fileobj[on].norm[ntris][2]);
*/
//printf("%f %f %f\n",fileobj[on].color[ntris][0],fileobj[on].color[ntris][1],fileobj[on].color[ntris][2]);
		ntris++;
	}
	size = ntris;
	fclose (fd);
//	printf("loadet : %s objectsize: %d triangels\n",fn,size);
//	printf("range: %d bspeed: %d amin: %d amax: %d\n",fileobj[on].range,fileobj[on].bulletspeed,fileobj[on].anglemin,fileobj[on].anglemax);
}
